
/*
 * 64 bit scaled idct
 * and YUV->RGB converter
 *
 */

#define uchar	unsigned char
#define uint	unsigned int
#define ulong	unsigned long
#define int64	long long
#define uint64	unsigned long long

#define rep4l(x)	(x|(x<<16ULL)|(x<<32ULL)|(x<<48ULL))
#define rep4(x)		rep4l(((uint64) (x)))

#define asmv	asm volatile



void yuv2rgb_420(uchar *rgb,long d0,long d1,uchar *yuv)
{
	register ulong	i,y8a,y8b,ya,yb,yc,yd,u8,v8,u4a,u4b,v4a,v4b,ua,va,ub,vb,uc,vc,ud,vd;
	register ulong	ux,uy,uz,ut,vx,vy,vz,vt,wx,wy,wz,wt;
	register ulong	ra,ga,ba,rb,gb,bb,rc,gc,bc,rd,gd,bd;
	register ulong	uvofs,c0,c1,c2,c3;
	register uchar	*u,*v,*y0,*y1;
	register uchar	*rgb0,*rgb1;

	uvofs=0x0080008000800080UL;
	c0   =rep4( 128.0*0.114/0.331+0.5 );
	c1   =rep4( 128.0*0.299/0.419+0.5 );
	c2   =rep4( 128.0*0.587/0.331+0.5 );
	c3   =rep4( 128.0*0.419/0.299+0.5 );

	y0=yuv;
	y1=yuv+ 64;
	u =yuv+256;
	v =yuv+320;
	rgb0=rgb;
	rgb1=rgb+d0;
	d0<<=1;
	d1-=7*d0;

	for (i=16; i; i--)
	{

		if ( !(i&1) )
		{
			asmv("ld8 %0=[%1],8" : "=r"(u8),"=r"(u) : "r"(u) );
			asmv("ld8 %0=[%1],8" : "=r"(v8),"=r"(v) : "r"(v) );

			asmv("unpack1.l %0=r0,%1" : "=r"(u4a) : "r"(u8));
			asmv("unpack1.l %0=r0,%1" : "=r"(v4a) : "r"(v8));
			asmv("unpack1.h %0=r0,%1" : "=r"(u4b) : "r"(u8));
			asmv("unpack1.h %0=r0,%1" : "=r"(v4b) : "r"(v8));

			asmv("psub2 %0=%1,%2" : "=r"(u4a) : "r"(u4a), "r"(uvofs) );
			asmv("psub2 %0=%1,%2" : "=r"(v4a) : "r"(v4a), "r"(uvofs) );
			asmv("psub2 %0=%1,%2" : "=r"(u4b) : "r"(u4b), "r"(uvofs) );
			asmv("psub2 %0=%1,%2" : "=r"(v4b) : "r"(v4b), "r"(uvofs) );

			asmv("mux2 %0=%1, 80" : "=r"(ua) : "r"(u4a) );
			asmv("mux2 %0=%1, 80" : "=r"(va) : "r"(v4a) );
			asmv("mux2 %0=%1,250" : "=r"(ub) : "r"(u4a) );
			asmv("mux2 %0=%1,250" : "=r"(vb) : "r"(v4a) );
			asmv("mux2 %0=%1, 80" : "=r"(uc) : "r"(u4b) );
			asmv("mux2 %0=%1, 80" : "=r"(vc) : "r"(v4b) );
			asmv("mux2 %0=%1,250" : "=r"(ud) : "r"(u4b) );
			asmv("mux2 %0=%1,250" : "=r"(vd) : "r"(v4b) );
		}


		asmv("ld8 %0=[%1],8" : "=r"(y8a),"=r"(y0) : "r"(y0) );
		asmv("ld8 %0=[%1],8" : "=r"(y8b),"=r"(y1) : "r"(y1) );

		asmv("unpack1.l %0=r0,%1" : "=r"(ya) : "r"(y8a) );
		asmv("unpack1.h %0=r0,%1" : "=r"(yb) : "r"(y8a) );
		asmv("unpack1.l %0=r0,%1" : "=r"(yc) : "r"(y8b) );
		asmv("unpack1.h %0=r0,%1" : "=r"(yd) : "r"(y8b) );


		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wx) : "r"(ua), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wy) : "r"(ub), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wz) : "r"(uc), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wt) : "r"(ud), "r"(c0) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(u4a) : "r"(va), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(u4b) : "r"(vb), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(v4a) : "r"(vc), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(v4b) : "r"(vd), "r"(c1) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(ux) : "r"(ua), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(uy) : "r"(ub), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(uz) : "r"(uc), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(ut) : "r"(ud), "r"(c2) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vx) : "r"(va), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vy) : "r"(vb), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vz) : "r"(vc), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vt) : "r"(vd), "r"(c3) );


		asmv("padd2 %0=%1,%2" : "=r"(wx) : "r"(wx), "r"(u4a) );
		asmv("padd2 %0=%1,%2" : "=r"(wy) : "r"(wy), "r"(u4b) );
		asmv("padd2 %0=%1,%2" : "=r"(wz) : "r"(wz), "r"(v4a) );
		asmv("padd2 %0=%1,%2" : "=r"(wt) : "r"(wt), "r"(v4b) );


		asmv("padd2 %0=%1,%2" : "=r"(ba) : "r"(ya), "r"(ux) );
		asmv("padd2 %0=%1,%2" : "=r"(bb) : "r"(yb), "r"(uy) );
		asmv("padd2 %0=%1,%2" : "=r"(bc) : "r"(yc), "r"(uz) );
		asmv("padd2 %0=%1,%2" : "=r"(bd) : "r"(yd), "r"(ut) );
		asmv("psub2 %0=%1,%2" : "=r"(ga) : "r"(ya), "r"(wx) );
		asmv("psub2 %0=%1,%2" : "=r"(gb) : "r"(yb), "r"(wy) );
		asmv("psub2 %0=%1,%2" : "=r"(gc) : "r"(yc), "r"(wz) );
		asmv("psub2 %0=%1,%2" : "=r"(gd) : "r"(yd), "r"(wt) );
		asmv("padd2 %0=%1,%2" : "=r"(ra) : "r"(ya), "r"(vx) );
		asmv("padd2 %0=%1,%2" : "=r"(rb) : "r"(yb), "r"(vy) );
		asmv("padd2 %0=%1,%2" : "=r"(rc) : "r"(yc), "r"(vz) );
		asmv("padd2 %0=%1,%2" : "=r"(rd) : "r"(yd), "r"(vt) );


		asmv("pack2.uss %0=%1,%2" : "=r"(ba) : "r"(ba), "r"(ga) );
		asmv("pack2.uss %0=%1,%2" : "=r"(bb) : "r"(bb), "r"(gb) );
		asmv("pack2.uss %0=%1,r0" : "=r"(ra) : "r"(ra) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rb) : "r"(rb) );

		asmv("pack2.uss %0=%1,%2" : "=r"(bc) : "r"(bc), "r"(gc) );
		asmv("pack2.uss %0=%1,%2" : "=r"(bd) : "r"(bd), "r"(gd) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rc) : "r"(rc) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rd) : "r"(rd) );


		asmv("mux1 %0=%1,@shuf" : "=r"(ba) : "r"(ba) );
		asmv("mux1 %0=%1,@shuf" : "=r"(bb) : "r"(bb) );
		asmv("mux1 %0=%1,@shuf" : "=r"(ra) : "r"(ra) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rb) : "r"(rb) );

		asmv("mux1 %0=%1,@shuf" : "=r"(bc) : "r"(bc) );
		asmv("mux1 %0=%1,@shuf" : "=r"(bd) : "r"(bd) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rc) : "r"(rc) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rd) : "r"(rd) );


		asmv("unpack2.l %0=%1,%2" : "=r"(ga) : "r"(ra), "r"(ba) );
		asmv("unpack2.l %0=%1,%2" : "=r"(gb) : "r"(rb), "r"(bb) );
		asmv("unpack2.h %0=%1,%2" : "=r"(ra) : "r"(ra), "r"(ba) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rb) : "r"(rb), "r"(bb) );

		asmv("unpack2.l %0=%1,%2" : "=r"(gc) : "r"(rc), "r"(bc) );
		asmv("unpack2.l %0=%1,%2" : "=r"(gd) : "r"(rd), "r"(bd) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rc) : "r"(rc), "r"(bc) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rd) : "r"(rd), "r"(bd) );


		*((uint *) rgb0)=ga;		rgb0+=d0;
		*((uint *) rgb1)=ga>>32;	rgb1+=d0;
		*((uint *) rgb0)=ra;		rgb0+=d0;
		*((uint *) rgb1)=ra>>32;	rgb1+=d0;
		*((uint *) rgb0)=gb;		rgb0+=d0;
		*((uint *) rgb1)=gb>>32;	rgb1+=d0;
		*((uint *) rgb0)=rb;		rgb0+=d0;
		*((uint *) rgb1)=rb>>32;	rgb1+=d0;
		*((uint *) rgb0)=gc;		rgb0+=d0;
		*((uint *) rgb1)=gc>>32;	rgb1+=d0;
		*((uint *) rgb0)=rc;		rgb0+=d0;
		*((uint *) rgb1)=rc>>32;	rgb1+=d0;
		*((uint *) rgb0)=gd;		rgb0+=d0;
		*((uint *) rgb1)=gd>>32;	rgb1+=d0;
		*((uint *) rgb0)=rd;		rgb0+=d1;
		*((uint *) rgb1)=rd>>32;	rgb1+=d1;


		if ( i==9 )
		{
			y0+=64;
			y1+=64;
		}
	}
}


void yuv2rgb_422(uchar *rgb,long d0,long d1,uchar *yuv)
{
	register ulong	i,y8a,y8b,ya,yb,yc,yd,u8,v8,u4a,u4b,v4a,v4b,ua,va,ub,vb,uc,vc,ud,vd;
	register ulong	ux,uy,uz,ut,vx,vy,vz,vt,wx,wy,wz,wt;
	register ulong	ra,ga,ba,rb,gb,bb,rc,gc,bc,rd,gd,bd;
	register ulong	uvofs,c0,c1,c2,c3;
	register uchar	*u,*v,*y0,*y1;
	register uchar	*rgb0,*rgb1;

	uvofs=0x0080008000800080UL;
	c0   =rep4( 128.0*0.114/0.331+0.5 );
	c1   =rep4( 128.0*0.299/0.419+0.5 );
	c2   =rep4( 128.0*0.587/0.331+0.5 );
	c3   =rep4( 128.0*0.419/0.299+0.5 );

	y0=yuv;
	y1=yuv+ 64;
	u =yuv+128;
	v =yuv+192;
	rgb0=rgb;
	rgb1=rgb+d0;
	d0<<=1;
	d1-=7*d0;

	for (i=8; i; i--)
	{
		asmv("ld8 %0=[%1],8" : "=r"(u8),"=r"(u) : "r"(u) );
		asmv("ld8 %0=[%1],8" : "=r"(v8),"=r"(v) : "r"(v) );

		asmv("ld8 %0=[%1],8" : "=r"(y8a),"=r"(y0) : "r"(y0) );
		asmv("ld8 %0=[%1],8" : "=r"(y8b),"=r"(y1) : "r"(y1) );

		asmv("unpack1.l %0=r0,%1" : "=r"(u4a) : "r"(u8));
		asmv("unpack1.l %0=r0,%1" : "=r"(v4a) : "r"(v8));
		asmv("unpack1.h %0=r0,%1" : "=r"(u4b) : "r"(u8));
		asmv("unpack1.h %0=r0,%1" : "=r"(v4b) : "r"(v8));

		asmv("psub2 %0=%1,%2" : "=r"(u4a) : "r"(u4a), "r"(uvofs) );
		asmv("psub2 %0=%1,%2" : "=r"(v4a) : "r"(v4a), "r"(uvofs) );
		asmv("psub2 %0=%1,%2" : "=r"(u4b) : "r"(u4b), "r"(uvofs) );
		asmv("psub2 %0=%1,%2" : "=r"(v4b) : "r"(v4b), "r"(uvofs) );

		asmv("unpack1.l %0=r0,%1" : "=r"(ya) : "r"(y8a) );
		asmv("unpack1.h %0=r0,%1" : "=r"(yb) : "r"(y8a) );
		asmv("unpack1.l %0=r0,%1" : "=r"(yc) : "r"(y8b) );
		asmv("unpack1.h %0=r0,%1" : "=r"(yd) : "r"(y8b) );


		asmv("mux2 %0=%1, 80" : "=r"(ua) : "r"(u4a) );
		asmv("mux2 %0=%1, 80" : "=r"(va) : "r"(v4a) );
		asmv("mux2 %0=%1,250" : "=r"(ub) : "r"(u4a) );
		asmv("mux2 %0=%1,250" : "=r"(vb) : "r"(v4a) );
		asmv("mux2 %0=%1, 80" : "=r"(uc) : "r"(u4b) );
		asmv("mux2 %0=%1, 80" : "=r"(vc) : "r"(v4b) );
		asmv("mux2 %0=%1,250" : "=r"(ud) : "r"(u4b) );
		asmv("mux2 %0=%1,250" : "=r"(vd) : "r"(v4b) );


		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wx) : "r"(ua), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wy) : "r"(ub), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wz) : "r"(uc), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wt) : "r"(ud), "r"(c0) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(u4a) : "r"(va), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(u4b) : "r"(vb), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(v4a) : "r"(vc), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(v4b) : "r"(vd), "r"(c1) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(ux) : "r"(ua), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(uy) : "r"(ub), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(uz) : "r"(uc), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(ut) : "r"(ud), "r"(c2) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vx) : "r"(va), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vy) : "r"(vb), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vz) : "r"(vc), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vt) : "r"(vd), "r"(c3) );


		asmv("padd2 %0=%1,%2" : "=r"(wx) : "r"(wx), "r"(u4a) );
		asmv("padd2 %0=%1,%2" : "=r"(wy) : "r"(wy), "r"(u4b) );
		asmv("padd2 %0=%1,%2" : "=r"(wz) : "r"(wz), "r"(v4a) );
		asmv("padd2 %0=%1,%2" : "=r"(wt) : "r"(wt), "r"(v4b) );


		asmv("padd2 %0=%1,%2" : "=r"(ba) : "r"(ya), "r"(ux) );
		asmv("padd2 %0=%1,%2" : "=r"(bb) : "r"(yb), "r"(uy) );
		asmv("padd2 %0=%1,%2" : "=r"(bc) : "r"(yc), "r"(uz) );
		asmv("padd2 %0=%1,%2" : "=r"(bd) : "r"(yd), "r"(ut) );
		asmv("psub2 %0=%1,%2" : "=r"(ga) : "r"(ya), "r"(wx) );
		asmv("psub2 %0=%1,%2" : "=r"(gb) : "r"(yb), "r"(wy) );
		asmv("psub2 %0=%1,%2" : "=r"(gc) : "r"(yc), "r"(wz) );
		asmv("psub2 %0=%1,%2" : "=r"(gd) : "r"(yd), "r"(wt) );
		asmv("padd2 %0=%1,%2" : "=r"(ra) : "r"(ya), "r"(vx) );
		asmv("padd2 %0=%1,%2" : "=r"(rb) : "r"(yb), "r"(vy) );
		asmv("padd2 %0=%1,%2" : "=r"(rc) : "r"(yc), "r"(vz) );
		asmv("padd2 %0=%1,%2" : "=r"(rd) : "r"(yd), "r"(vt) );


		asmv("pack2.uss %0=%1,%2" : "=r"(ba) : "r"(ba), "r"(ga) );
		asmv("pack2.uss %0=%1,%2" : "=r"(bb) : "r"(bb), "r"(gb) );
		asmv("pack2.uss %0=%1,r0" : "=r"(ra) : "r"(ra) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rb) : "r"(rb) );

		asmv("pack2.uss %0=%1,%2" : "=r"(bc) : "r"(bc), "r"(gc) );
		asmv("pack2.uss %0=%1,%2" : "=r"(bd) : "r"(bd), "r"(gd) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rc) : "r"(rc) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rd) : "r"(rd) );


		asmv("mux1 %0=%1,@shuf" : "=r"(ba) : "r"(ba) );
		asmv("mux1 %0=%1,@shuf" : "=r"(bb) : "r"(bb) );
		asmv("mux1 %0=%1,@shuf" : "=r"(ra) : "r"(ra) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rb) : "r"(rb) );

		asmv("mux1 %0=%1,@shuf" : "=r"(bc) : "r"(bc) );
		asmv("mux1 %0=%1,@shuf" : "=r"(bd) : "r"(bd) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rc) : "r"(rc) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rd) : "r"(rd) );


		asmv("unpack2.l %0=%1,%2" : "=r"(ga) : "r"(ra), "r"(ba) );
		asmv("unpack2.l %0=%1,%2" : "=r"(gb) : "r"(rb), "r"(bb) );
		asmv("unpack2.h %0=%1,%2" : "=r"(ra) : "r"(ra), "r"(ba) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rb) : "r"(rb), "r"(bb) );

		asmv("unpack2.l %0=%1,%2" : "=r"(gc) : "r"(rc), "r"(bc) );
		asmv("unpack2.l %0=%1,%2" : "=r"(gd) : "r"(rd), "r"(bd) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rc) : "r"(rc), "r"(bc) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rd) : "r"(rd), "r"(bd) );


		*((uint *) rgb0)=ga;		rgb0+=d0;
		*((uint *) rgb1)=ga>>32;	rgb1+=d0;
		*((uint *) rgb0)=ra;		rgb0+=d0;
		*((uint *) rgb1)=ra>>32;	rgb1+=d0;
		*((uint *) rgb0)=gb;		rgb0+=d0;
		*((uint *) rgb1)=gb>>32;	rgb1+=d0;
		*((uint *) rgb0)=rb;		rgb0+=d0;
		*((uint *) rgb1)=rb>>32;	rgb1+=d0;
		*((uint *) rgb0)=gc;		rgb0+=d0;
		*((uint *) rgb1)=gc>>32;	rgb1+=d0;
		*((uint *) rgb0)=rc;		rgb0+=d0;
		*((uint *) rgb1)=rc>>32;	rgb1+=d0;
		*((uint *) rgb0)=gd;		rgb0+=d0;
		*((uint *) rgb1)=gd>>32;	rgb1+=d0;
		*((uint *) rgb0)=rd;		rgb0+=d1;
		*((uint *) rgb1)=rd>>32;	rgb1+=d1;
	}
}


void yuv2rgb_440(uchar *rgb,long d0,long d1,uchar *yuv)
{
	register ulong	i,y8,ya,yb,u8,v8,ua,va,ub,vb,ux,uy,vx,vy,wx,wy,wa,wb,ra,ga,ba,rb,gb,bb;
	register ulong	uvofs,c0,c1,c2,c3;
	register uchar	*u,*v;
	register uchar	*rgb0,*rgb1;

	uvofs=0x0080008000800080UL;
	c0   =rep4( 128.0*0.114/0.331+0.5 );
	c1   =rep4( 128.0*0.299/0.419+0.5 );
	c2   =rep4( 128.0*0.587/0.331+0.5 );
	c3   =rep4( 128.0*0.419/0.299+0.5 );

	u=yuv+128;
	v=yuv+192;
	rgb0=rgb;
	rgb1=rgb+d0;
	d0<<=1;
	d1-=3*d0;

	for (i=16; i; i--)
	{
		if ( !(i&1) )
		{
			asmv("ld8 %0=[%1],8" : "=r"(u8),"=r"(u) : "r"(u) );
			asmv("ld8 %0=[%1],8" : "=r"(v8),"=r"(v) : "r"(v) );

			asmv("unpack1.l %0=r0,%1" : "=r"(ua) : "r"(u8));
			asmv("unpack1.l %0=r0,%1" : "=r"(va) : "r"(v8));
			asmv("unpack1.h %0=r0,%1" : "=r"(ub) : "r"(u8));
			asmv("unpack1.h %0=r0,%1" : "=r"(vb) : "r"(v8));


			asmv("psub2 %0=%1,%2" : "=r"(ua) : "r"(ua), "r"(uvofs) );
			asmv("psub2 %0=%1,%2" : "=r"(va) : "r"(va), "r"(uvofs) );
			asmv("psub2 %0=%1,%2" : "=r"(ub) : "r"(ub), "r"(uvofs) );
			asmv("psub2 %0=%1,%2" : "=r"(vb) : "r"(vb), "r"(uvofs) );

			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wx) : "r"(ua), "r"(c0) );
			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wy) : "r"(ub), "r"(c0) );

			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wa) : "r"(va), "r"(c1) );
			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wb) : "r"(vb), "r"(c1) );

			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(ux) : "r"(ua), "r"(c2) );
			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(uy) : "r"(ub), "r"(c2) );

			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vx) : "r"(va), "r"(c3) );
			asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vy) : "r"(vb), "r"(c3) );

			asmv("padd2 %0=%1,%2" : "=r"(wx) : "r"(wx), "r"(wa) );
			asmv("padd2 %0=%1,%2" : "=r"(wy) : "r"(wy), "r"(wb) );
		}

		asmv("ld8 %0=[%1],8" : "=r"(y8),"=r"(yuv) : "r"(yuv) );

		asmv("unpack1.l %0=r0,%1" : "=r"(ya) : "r"(y8) );
		asmv("unpack1.h %0=r0,%1" : "=r"(yb) : "r"(y8) );

		asmv("padd2 %0=%1,%2" : "=r"(ba) : "r"(ya), "r"(ux) );
		asmv("padd2 %0=%1,%2" : "=r"(bb) : "r"(yb), "r"(uy) );
		asmv("psub2 %0=%1,%2" : "=r"(ga) : "r"(ya), "r"(wx) );
		asmv("psub2 %0=%1,%2" : "=r"(gb) : "r"(yb), "r"(wy) );
		asmv("padd2 %0=%1,%2" : "=r"(ra) : "r"(ya), "r"(vx) );
		asmv("padd2 %0=%1,%2" : "=r"(rb) : "r"(yb), "r"(vy) );


		asmv("pack2.uss %0=%1,%2" : "=r"(ba) : "r"(ba), "r"(ga) );
		asmv("pack2.uss %0=%1,%2" : "=r"(bb) : "r"(bb), "r"(gb) );

		asmv("pack2.uss %0=%1,r0" : "=r"(ra) : "r"(ra) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rb) : "r"(rb) );

		asmv("mux1 %0=%1,@shuf" : "=r"(ba) : "r"(ba) );
		asmv("mux1 %0=%1,@shuf" : "=r"(bb) : "r"(bb) );
		asmv("mux1 %0=%1,@shuf" : "=r"(ra) : "r"(ra) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rb) : "r"(rb) );


		asmv("unpack2.l %0=%1,%2" : "=r"(ga) : "r"(ra), "r"(ba) );
		asmv("unpack2.l %0=%1,%2" : "=r"(gb) : "r"(rb), "r"(bb) );
		asmv("unpack2.h %0=%1,%2" : "=r"(ra) : "r"(ra), "r"(ba) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rb) : "r"(rb), "r"(bb) );


		*((uint *) rgb0)=ga;		rgb0+=d0;
		*((uint *) rgb1)=ga>>32;	rgb1+=d0;
		*((uint *) rgb0)=ra;		rgb0+=d0;
		*((uint *) rgb1)=ra>>32;	rgb1+=d0;
		*((uint *) rgb0)=gb;		rgb0+=d0;
		*((uint *) rgb1)=gb>>32;	rgb1+=d0;
		*((uint *) rgb0)=rb;		rgb0+=d1;
		*((uint *) rgb1)=rb>>32;	rgb1+=d1;
	}
}


void yuv2rgb_444(uchar *rgb,long d0,long d1,uchar *yuv)
{
	register ulong	i,y8,ya,yb,u8,v8,ua,va,ub,vb,ux,uy,vx,vy,wx,wy,ra,ga,ba,rb,gb,bb;
	register ulong	uvofs,c0,c1,c2,c3;
	register uchar	*u,*v;
	register uchar	*rgb0,*rgb1;

	uvofs=0x0080008000800080UL;
	c0   =rep4( 128.0*0.114/0.331+0.5 );
	c1   =rep4( 128.0*0.299/0.419+0.5 );
	c2   =rep4( 128.0*0.587/0.331+0.5 );
	c3   =rep4( 128.0*0.419/0.299+0.5 );

	u=yuv+ 64;
	v=yuv+128;
	rgb0=rgb;
	rgb1=rgb+d0;
	d0<<=1;
	d1-=3*d0;

	for (i=8; i; i--)
	{
		asmv("ld8 %0=[%1],8" : "=r"(u8),"=r"(u) : "r"(u) );
		asmv("ld8 %0=[%1],8" : "=r"(v8),"=r"(v) : "r"(v) );

		asmv("ld8 %0=[%1],8" : "=r"(y8),"=r"(yuv) : "r"(yuv) );
		asmv("unpack1.l %0=r0,%1" : "=r"(ua) : "r"(u8));
		asmv("unpack1.l %0=r0,%1" : "=r"(va) : "r"(v8));
		asmv("unpack1.h %0=r0,%1" : "=r"(ub) : "r"(u8));
		asmv("unpack1.h %0=r0,%1" : "=r"(vb) : "r"(v8));

		asmv("unpack1.l %0=r0,%1" : "=r"(ya) : "r"(y8) );
		asmv("unpack1.h %0=r0,%1" : "=r"(yb) : "r"(y8) );

		asmv("psub2 %0=%1,%2" : "=r"(ua) : "r"(ua), "r"(uvofs) );
		asmv("psub2 %0=%1,%2" : "=r"(va) : "r"(va), "r"(uvofs) );
		asmv("psub2 %0=%1,%2" : "=r"(ub) : "r"(ub), "r"(uvofs) );
		asmv("psub2 %0=%1,%2" : "=r"(vb) : "r"(vb), "r"(uvofs) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wx) : "r"(ua), "r"(c0) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(wy) : "r"(ub), "r"(c0) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(u8) : "r"(va), "r"(c1) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(v8) : "r"(vb), "r"(c1) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(ux) : "r"(ua), "r"(c2) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(uy) : "r"(ub), "r"(c2) );

		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vx) : "r"(va), "r"(c3) );
		asmv("pmpyshr2 %0=%1,%2,7" : "=r"(vy) : "r"(vb), "r"(c3) );

		asmv("padd2 %0=%1,%2" : "=r"(wx) : "r"(wx), "r"(u8) );
		asmv("padd2 %0=%1,%2" : "=r"(wy) : "r"(wy), "r"(v8) );


		asmv("padd2 %0=%1,%2" : "=r"(ba) : "r"(ya), "r"(ux) );
		asmv("padd2 %0=%1,%2" : "=r"(bb) : "r"(yb), "r"(uy) );
		asmv("psub2 %0=%1,%2" : "=r"(ga) : "r"(ya), "r"(wx) );
		asmv("psub2 %0=%1,%2" : "=r"(gb) : "r"(yb), "r"(wy) );
		asmv("padd2 %0=%1,%2" : "=r"(ra) : "r"(ya), "r"(vx) );
		asmv("padd2 %0=%1,%2" : "=r"(rb) : "r"(yb), "r"(vy) );


		asmv("pack2.uss %0=%1,%2" : "=r"(ba) : "r"(ba), "r"(ga) );
		asmv("pack2.uss %0=%1,%2" : "=r"(bb) : "r"(bb), "r"(gb) );

		asmv("pack2.uss %0=%1,r0" : "=r"(ra) : "r"(ra) );
		asmv("pack2.uss %0=%1,r0" : "=r"(rb) : "r"(rb) );

		asmv("mux1 %0=%1,@shuf" : "=r"(ba) : "r"(ba) );
		asmv("mux1 %0=%1,@shuf" : "=r"(bb) : "r"(bb) );
		asmv("mux1 %0=%1,@shuf" : "=r"(ra) : "r"(ra) );
		asmv("mux1 %0=%1,@shuf" : "=r"(rb) : "r"(rb) );


		asmv("unpack2.l %0=%1,%2" : "=r"(ga) : "r"(ra), "r"(ba) );
		asmv("unpack2.l %0=%1,%2" : "=r"(gb) : "r"(rb), "r"(bb) );
		asmv("unpack2.h %0=%1,%2" : "=r"(ra) : "r"(ra), "r"(ba) );
		asmv("unpack2.h %0=%1,%2" : "=r"(rb) : "r"(rb), "r"(bb) );


		*((uint *) rgb0)=ga;		rgb0+=d0;
		*((uint *) rgb1)=ga>>32;	rgb1+=d0;
		*((uint *) rgb0)=ra;		rgb0+=d0;
		*((uint *) rgb1)=ra>>32;	rgb1+=d0;
		*((uint *) rgb0)=gb;		rgb0+=d0;
		*((uint *) rgb1)=gb>>32;	rgb1+=d0;
		*((uint *) rgb0)=rb;		rgb0+=d1;
		*((uint *) rgb1)=rb>>32;	rgb1+=d1;
	}
}

