
/*
 * scaled idct
 * and YUV->RGB converter
 * 32 bit version
 *
 */

#define uchar	unsigned char
#define ushort	unsigned short
#define ulong	unsigned long
#define int64	long long
#define uint64	unsigned long long

#include "mmx.h"

#define asmv	asm volatile

void sidct(uchar *y,short *x)
{
	static uint64	mc[4] = { 7641036310748752394ull, 4328306761599630353ull,
				  1519988067414840600ull, 7136625455784420106ull };
	short		z[128];
	register short	*zp,*tp;
	register long	n;
	uint64		t0,t2,t4,t6,tmp;

	n=2;
	tp=z;

	do
	{
		asmv("movq %0,%%mm1" : : "m"(x[ 0]) );
		asmv("movq %0,%%mm0" : : "m"(x[ 8]) );
		asmv("movq %0,%%mm2" : : "m"(x[16]) );
		asmv("movq %0,%%mm3" : : "m"(x[24]) );

		asmv("movq %mm1,%mm4");
		asmv("movq %mm2,%mm6");
		asmv("punpcklwd %mm0,%mm1");
		asmv("punpckhwd %mm0,%mm4");
		asmv("punpcklwd %mm3,%mm2");
		asmv("punpckhwd %mm3,%mm6");

		asmv("movq %mm1,%mm0");
		asmv("movq %mm4,%mm3");
		asmv("punpckldq %mm2,%mm1");
		asmv("punpckhdq %mm2,%mm0");
		asmv("punpckldq %mm6,%mm4");
		asmv("punpckhdq %mm6,%mm3");

		asmv("pxor %mm5,%mm5");

		asmv("movq %%mm1,%0" : "=m"(t0) );
		asmv("movq %%mm4,%0" : "=m"(t2) );

		asmv("movq %0,%%mm4" : : "m"(x[ 4]) );
		asmv("movq %0,%%mm7" : : "m"(x[12]) );
		asmv("movq %0,%%mm2" : : "m"(x[20]) );
		asmv("movq %0,%%mm1" : : "m"(x[28]) );

		asmv("movq %%mm5,%0" : "=m"(x[ 0]) );
		asmv("movq %%mm5,%0" : "=m"(x[ 4]) );
		asmv("movq %%mm5,%0" : "=m"(x[ 8]) );
		asmv("movq %%mm5,%0" : "=m"(x[12]) );
		asmv("movq %%mm5,%0" : "=m"(x[16]) );
		asmv("movq %%mm5,%0" : "=m"(x[20]) );
		asmv("movq %%mm5,%0" : "=m"(x[24]) );
		asmv("movq %%mm5,%0" : "=m"(x[28]) );

		asmv("movq %mm4,%mm5");
		asmv("movq %mm2,%mm6");
		asmv("punpcklwd %mm7,%mm4");
		asmv("punpckhwd %mm7,%mm5");
		asmv("punpcklwd %mm1,%mm2");
		asmv("punpckhwd %mm1,%mm6");

		asmv("movq %mm4,%mm7");
		asmv("movq %mm5,%mm1");
		asmv("punpckldq %mm2,%mm4");
		asmv("punpckhdq %mm2,%mm7");
		asmv("punpckldq %mm6,%mm5");
		asmv("punpckhdq %mm6,%mm1");

		asmv("movq %%mm4,%0" : "=m"(t4) );
		asmv("movq %%mm5,%0" : "=m"(t6) );

		asmv("movq %mm0,%mm2");
		asmv("paddw %mm1,%mm0");
		asmv("psubw %mm1,%mm2");

		asmv("movq %mm3,%mm5");
		asmv("paddw %mm7,%mm3");
		asmv("psubw %mm5,%mm7");
		asmv("movq %mm0,%mm6");
		asmv("psubw %mm3,%mm0");
		asmv("paddw %mm3,%mm6");

		asmv("movq %mm0,%mm4");
		asmv("pmulhw %0,%%mm0" : : "m"(mc[0]) );	// mm0 =(27146*mm0)>>16;
		asmv("paddw %mm4,%mm0");

		asmv("movq %mm2,%mm1");
		asmv("paddw %mm7,%mm1");

		asmv("movq %mm1,%mm4");
		asmv("pmulhw %0,%%mm4" : : "m"(mc[1]) );	// mm4 =(15377*mm4)>>16;
		asmv("psubw %mm4,%mm1");

		asmv("movq %mm7,%mm4");
		asmv("pmulhw %0,%%mm4" : : "m"(mc[2]) );	// mm4 =(5400*mm4)>>16;
		asmv("paddw %mm7,%mm4");

		asmv("paddw %mm1,%mm4");

		asmv("movq %mm2,%mm7");
		asmv("paddw %mm2,%mm2");
		asmv("paddw %mm7,%mm2");
		asmv("pmulhw %0,%%mm7" : : "m"(mc[3]) );	// mm2 =(25354*mm2)>>16;
		asmv("psubw %mm7,%mm2");

		asmv("psubw %mm1,%mm2");
		asmv("psubw %mm6,%mm2");

		asmv("movq %0,%%mm1" : : "m"(t2) );
		asmv("movq %0,%%mm3" : : "m"(t6) );
		asmv("movq %mm1,%mm5");
		asmv("psubw %mm3,%mm1");
		asmv("paddw %mm3,%mm5");

		asmv("movq %mm1,%mm7");
		asmv("pmulhw %0,%%mm1" : : "m"(mc[0]) );	// mm1 =(27146*mm1)>>16;
		asmv("paddw %mm7,%mm1");

		asmv("psubw %mm2,%mm0");
		asmv("psubw %mm0,%mm4");

		asmv("movq %%mm4,%0" : "=m"(tmp) );

		asmv("psubw %mm5,%mm1");

		asmv("movq %0,%%mm3" : : "m"(t0) );
		asmv("movq %0,%%mm7" : : "m"(t4) );
		asmv("psubw %mm7,%mm3");
		asmv("paddw %0,%%mm7" : : "m"(t0) );

		asmv("movq %mm3,%mm4");
		asmv("paddw %mm1,%mm3");
		asmv("psubw %mm1,%mm4");

		asmv("movq %mm4,%mm1");
		asmv("paddw %mm0,%mm4");
		asmv("psubw %mm0,%mm1");

		asmv("movq %%mm4,%0" : "=m"(tp[16]) );
		asmv("movq %%mm1,%0" : "=m"(tp[40]) );

		asmv("movq %mm7,%mm4");
		asmv("paddw %mm5,%mm7");
		asmv("psubw %mm5,%mm4");

		asmv("movq %mm3,%mm0");
		asmv("paddw %mm2,%mm3");
		asmv("psubw %mm2,%mm0");

		asmv("movq %%mm3,%0" : "=m"(tp[ 8]) );
		asmv("movq %%mm0,%0" : "=m"(tp[48]) );

		asmv("movq %mm7,%mm0");
		asmv("paddw %mm6,%mm7");
		asmv("psubw %mm6,%mm0");

		asmv("movq %%mm7,%0" : "=m"(tp[ 0]) );
		asmv("movq %%mm0,%0" : "=m"(tp[56]) );

		asmv("movq %mm4,%mm0");
		asmv("movq %0,%%mm1" : : "m"(tmp) );
		asmv("psubw %mm1,%mm4");
		asmv("paddw %mm1,%mm0");

		asmv("movq %%mm4,%0" : "=m"(tp[32]) );
		asmv("movq %%mm0,%0" : "=m"(tp[24]) );

		x+=4*8;
		tp+=4;
	}
	while (--n);

	n=2;
	zp=z;
	tp=z+64;

	do
	{
		asmv("movq %0,%%mm1" : : "m"(zp[ 0]) );
		asmv("movq %0,%%mm0" : : "m"(zp[ 8]) );
		asmv("movq %0,%%mm2" : : "m"(zp[16]) );
		asmv("movq %0,%%mm3" : : "m"(zp[24]) );

		asmv("movq %mm1,%mm4");
		asmv("movq %mm2,%mm6");
		asmv("punpcklwd %mm0,%mm1");
		asmv("punpckhwd %mm0,%mm4");
		asmv("punpcklwd %mm3,%mm2");
		asmv("punpckhwd %mm3,%mm6");

		asmv("movq %mm1,%mm0");
		asmv("movq %mm4,%mm3");
		asmv("punpckldq %mm2,%mm1");
		asmv("punpckhdq %mm2,%mm0");
		asmv("punpckldq %mm6,%mm4");
		asmv("punpckhdq %mm6,%mm3");

		asmv("movq %%mm1,%0" : "=m"(t0) );
		asmv("movq %%mm4,%0" : "=m"(t2) );

		asmv("movq %0,%%mm4" : : "m"(zp[ 4]) );
		asmv("movq %0,%%mm7" : : "m"(zp[12]) );
		asmv("movq %0,%%mm2" : : "m"(zp[20]) );
		asmv("movq %0,%%mm1" : : "m"(zp[28]) );

		asmv("movq %mm4,%mm5");
		asmv("movq %mm2,%mm6");
		asmv("punpcklwd %mm7,%mm4");
		asmv("punpckhwd %mm7,%mm5");
		asmv("punpcklwd %mm1,%mm2");
		asmv("punpckhwd %mm1,%mm6");

		asmv("movq %mm4,%mm7");
		asmv("movq %mm5,%mm1");
		asmv("punpckldq %mm2,%mm4");
		asmv("punpckhdq %mm2,%mm7");
		asmv("punpckldq %mm6,%mm5");
		asmv("punpckhdq %mm6,%mm1");

		asmv("movq %%mm4,%0" : "=m"(t4) );
		asmv("movq %%mm5,%0" : "=m"(t6) );


		asmv("movq %mm0,%mm2");
		asmv("paddw %mm1,%mm0");
		asmv("psubw %mm1,%mm2");

		asmv("movq %mm3,%mm5");
		asmv("paddw %mm7,%mm3");
		asmv("psubw %mm5,%mm7");
		asmv("movq %mm0,%mm6");
		asmv("psubw %mm3,%mm0");
		asmv("paddw %mm3,%mm6");

		asmv("movq %mm0,%mm4");
		asmv("pmulhw %0,%%mm0" : : "m"(mc[0]) );	// mm0 =(27146*mm0)>>16;
		asmv("paddw %mm4,%mm0");

		asmv("movq %mm2,%mm1");
		asmv("paddw %mm7,%mm1");

		asmv("movq %mm1,%mm4");
		asmv("pmulhw %0,%%mm4" : : "m"(mc[1]) );	// mm4 =(15377*mm4)>>16;
		asmv("psubw %mm4,%mm1");

		asmv("movq %mm7,%mm4");
		asmv("pmulhw %0,%%mm4" : : "m"(mc[2]) );	// mm4 =(5400*mm4)>>16;
		asmv("paddw %mm7,%mm4");

		asmv("paddw %mm1,%mm4");

		asmv("movq %mm2,%mm7");
		asmv("paddw %mm2,%mm2");
		asmv("paddw %mm7,%mm2");
		asmv("pmulhw %0,%%mm7" : : "m"(mc[3]) );	// mm2 =(25354*mm2)>>16;
		asmv("psubw %mm7,%mm2");

		asmv("psubw %mm1,%mm2");
		asmv("psubw %mm6,%mm2");

		asmv("movq %0,%%mm1" : : "m"(t2) );
		asmv("movq %0,%%mm3" : : "m"(t6) );
		asmv("movq %mm1,%mm5");
		asmv("psubw %mm3,%mm1");
		asmv("paddw %mm3,%mm5");

		asmv("movq %mm1,%mm7");
		asmv("pmulhw %0,%%mm1" : : "m"(mc[0]) );	// mm1 =(27146*mm1)>>16;
		asmv("paddw %mm7,%mm1");

		asmv("psubw %mm2,%mm0");
		asmv("psubw %mm0,%mm4");

		asmv("movq %%mm4,%0" : "=m"(tmp) );

		asmv("psubw %mm5,%mm1");

		asmv("movq %0,%%mm3" : : "m"(t0) );
		asmv("movq %0,%%mm7" : : "m"(t4) );
		asmv("psubw %mm7,%mm3");
		asmv("paddw %0,%%mm7" : : "m"(t0) );

		asmv("movq %mm3,%mm4");
		asmv("paddw %mm1,%mm3");
		asmv("psubw %mm1,%mm4");

		asmv("movq %mm4,%mm1");
		asmv("paddw %mm0,%mm4");
		asmv("psubw %mm0,%mm1");

		asmv("movq %%mm4,%0" : "=m"(tp[16]) );
		asmv("movq %%mm1,%0" : "=m"(tp[40]) );

		asmv("movq %mm7,%mm4");
		asmv("paddw %mm5,%mm7");
		asmv("psubw %mm5,%mm4");

		asmv("movq %mm3,%mm0");
		asmv("paddw %mm2,%mm3");
		asmv("psubw %mm2,%mm0");

		asmv("movq %%mm3,%0" : "=m"(tp[ 8]) );
		asmv("movq %%mm0,%0" : "=m"(tp[48]) );

		asmv("movq %mm7,%mm0");
		asmv("paddw %mm6,%mm7");
		asmv("psubw %mm6,%mm0");

		asmv("movq %%mm7,%0" : "=m"(tp[ 0]) );
		asmv("movq %%mm0,%0" : "=m"(tp[56]) );

		asmv("movq %mm4,%mm0");
		asmv("movq %0,%%mm1" : : "m"(tmp) );
		asmv("psubw %mm1,%mm4");
		asmv("paddw %mm1,%mm0");

		asmv("movq %%mm4,%0" : "=m"(tp[32]) );
		asmv("movq %%mm0,%0" : "=m"(tp[24]) );

		zp+=4*8;
		tp+=4;
	}
	while (--n);

	n=8;
	x-=64;

	do
	{
		asmv("movq %0,%%mm0" : : "m"(zp[0]) );
		asmv("movq %0,%%mm1" : : "m"(zp[4]) );
		asmv("psraw $6,%mm0");
		asmv("psraw $6,%mm1");
		asmv("packuswb %mm1,%mm0");
		asmv("movq %%mm0,%0" : "=m"(y[0]) );
		zp+=8;
		y+=8;
	}
	while ( --n );

	asmv("emms");
}



#define rep4l(x)	(x|(x<<16)|(x<<32)|(x<<48))
#define rep4(x)		rep4l(((uint64) (x)))

#define getuv(rt,r0,r1,uv,n)	\
	pxor_r2r(rt,rt);		\
	punpcklbw_m2r(uv[n],rt);	\
	pxor_m2r(c[0],rt);		\
	movq_r2r(rt,r1);		\
	psrlq_i2r(8,r1);		\
	por_r2r(r1,rt);			\
	pxor_r2r(r0,r0);		\
	pxor_r2r(r1,r1);		\
	punpcklbw_r2r(rt,r0);		\
	punpckhbw_r2r(rt,r1)

#define gety(r0,y,n)	\
	pxor_r2r(r0,r0);		\
	punpcklbw_m2r(y[n],r0);		\
	psrlq_i2r(2,r0);		\
	paddw_m2r(c[5],r0)

#define wrgb(p,dp,r,g,b)	\
		p[0]=b;     p[1]=g;     p[2]=r;		p+=dp;	\
		p[0]=b>> 8; p[1]=g>> 8; p[2]=r>> 8;	p+=dp;	\
		p[0]=b>>16; p[1]=g>>16; p[2]=r>>16;	p+=dp;	\
		p[0]=b>>24; p[1]=g>>24; p[2]=r>>24;	p+=dp

#define wrgb2(p,dp,r,g,b,a,t)	\
		punpcklbw_r2r(g,b);		\
		punpcklbw_r2r(a,r);		\
		movq_r2r(b,t);			\
		punpcklwd_r2r(r,t);		\
		movd_r2m(t,*p);		p+=dp;	\
		psrlq_i2r(32,t);		\
		movd_r2m(t,*p);		p+=dp;	\
		punpckhwd_r2r(r,b);		\
		movd_r2m(b,*p);		p+=dp;	\
		psrlq_i2r(32,b);		\
		movd_r2m(b,*p);		p+=dp


void yuv2rgb_420(uchar *rgb,long d0,long d1,uchar *yuv)
{
	static uint64	c[6] = { 0x8000800080008000ULL, rep4(29032), rep4(22970), rep4(5638), rep4(11700), rep4(32) };
	register uchar	*uv, *p0,*p1;
	register long	i;

	uv=yuv+256;

	for (i=128; i; i>>=1)
	{
		p0=rgb;
		p1=rgb+d1;

		getuv(mm6,mm0,mm1,uv, 0);
		getuv(mm6,mm2,mm3,uv,64);

		gety(mm4,yuv,0);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
		movq_r2r(mm0,mm7);	pmulhw_m2r(c[3],mm7);	psubw_r2r(mm7,mm4);
		movq_r2r(mm2,mm7);	pmulhw_m2r(c[4],mm7);	psubw_r2r(mm7,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p0,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,4);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
		movq_r2r(mm1,mm7);	pmulhw_m2r(c[3],mm7);	psubw_r2r(mm7,mm4);
		movq_r2r(mm3,mm7);	pmulhw_m2r(c[4],mm7);	psubw_r2r(mm7,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p0,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,8);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm0);	psubw_r2r(mm0,mm4);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p1,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,12);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm4);
					pmulhw_m2r(c[4],mm3);	psubw_r2r(mm3,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p1,d0,mm6,mm4,mm5,mm7,mm7);


		getuv(mm6,mm0,mm1,uv, 4);
		getuv(mm6,mm2,mm3,uv,68);

		gety(mm4,yuv,64);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
		movq_r2r(mm0,mm7);	pmulhw_m2r(c[3],mm7);	psubw_r2r(mm7,mm4);
		movq_r2r(mm2,mm7);	pmulhw_m2r(c[4],mm7);	psubw_r2r(mm7,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p0,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,68);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
		movq_r2r(mm1,mm7);	pmulhw_m2r(c[3],mm7);	psubw_r2r(mm7,mm4);
		movq_r2r(mm3,mm7);	pmulhw_m2r(c[4],mm7);	psubw_r2r(mm7,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p0,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,72);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm0);	psubw_r2r(mm0,mm4);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p1,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,76);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm4);
					pmulhw_m2r(c[4],mm3);	psubw_r2r(mm3,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p1,d0,mm6,mm4,mm5,mm7,mm7);

		uv+=8;
		yuv+=16;
		yuv+=4*(i&16);
		rgb+=2*d1;
	}
}

void yuv2rgb_422(uchar *rgb,long d0,long d1,uchar *yuv)
{
	static uint64	c[6] = { 0x8000800080008000ULL, rep4(29032), rep4(22970), rep4(5638), rep4(11700), rep4(32) };
	register uchar	*p;
	register long	i;

	pxor_r2r(mm7,mm7);

	for (i=8; i; i--)
	{
		p=rgb;

		getuv(mm6,mm0,mm1,yuv,128);
		getuv(mm6,mm2,mm3,yuv,192);

		gety(mm4,yuv,0);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm0);	psubw_r2r(mm0,mm4);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);

		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p,d0,mm6,mm4,mm5,mm7,mm0);

		gety(mm4,yuv,4);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm4);
					pmulhw_m2r(c[4],mm3);	psubw_r2r(mm3,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);

		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p,d0,mm6,mm4,mm5,mm7,mm0);


		getuv(mm6,mm0,mm1,yuv,132);
		getuv(mm6,mm2,mm3,yuv,196);

		gety(mm4,yuv,64);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm0);	psubw_r2r(mm0,mm4);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);

		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p,d0,mm6,mm4,mm5,mm7,mm0);

		gety(mm4,yuv,68);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm4);
					pmulhw_m2r(c[4],mm3);	psubw_r2r(mm3,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);

		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p,d0,mm6,mm4,mm5,mm7,mm0);

		yuv+=8;
		rgb+=d1;
	}
}

#define getuv2(r0,y,n)	\
	pxor_r2r(r0,r0);		\
	punpcklbw_m2r(y[n],r0);		\
	psubb_m2r(c[0],r0)


void yuv2rgb_440(uchar *rgb,long d0,long d1,uchar *yuv)
{
	static uint64	c[6] = { 0x8000800080008000ULL, rep4(29032), rep4(22970), rep4(5638), rep4(11700), rep4(32) };
	register uchar	*uv, *p0,*p1;
	register long	i;

	uv=yuv+128;

	for (i=8; i; i--)
	{
		p0=rgb;
		p1=rgb+d1;

		getuv2(mm0,uv, 0);
		getuv2(mm1,uv, 4);
		getuv2(mm2,uv,64);
		getuv2(mm3,uv,68);

		gety(mm4,yuv,0);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
		movq_r2r(mm0,mm7);	pmulhw_m2r(c[3],mm7);	psubw_r2r(mm7,mm4);
		movq_r2r(mm2,mm7);	pmulhw_m2r(c[4],mm7);	psubw_r2r(mm7,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p0,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,4);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
		movq_r2r(mm1,mm7);	pmulhw_m2r(c[3],mm7);	psubw_r2r(mm7,mm4);
		movq_r2r(mm3,mm7);	pmulhw_m2r(c[4],mm7);	psubw_r2r(mm7,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p0,d0,mm6,mm4,mm5,mm7,mm7);


		gety(mm4,yuv,8);
		movq_r2r(mm0,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm2,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm0);	psubw_r2r(mm0,mm4);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p1,d0,mm6,mm4,mm5,mm7,mm7);

		gety(mm4,yuv,12);
		movq_r2r(mm1,mm5);	pmulhw_m2r(c[1],mm5);	paddw_r2r(mm4,mm5);	// mm5 = b
		movq_r2r(mm3,mm6);	pmulhw_m2r(c[2],mm6);	paddw_r2r(mm4,mm6);	// mm6 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm4);
					pmulhw_m2r(c[4],mm3);	psubw_r2r(mm3,mm4);	// mm4 = g
		psraw_i2r(6,mm5);	psraw_i2r(6,mm6);	psraw_i2r(6,mm4);
		pxor_r2r(mm7,mm7);
		packuswb_r2r(mm7,mm5);	packuswb_r2r(mm7,mm6);	packuswb_r2r(mm7,mm4);
		wrgb2(p1,d0,mm6,mm4,mm5,mm7,mm7);

		uv+=8;
		yuv+=16;
		rgb+=2*d1;
	}
}


void yuv2rgb_444(uchar *rgb,long d0,long d1,uchar *yuv)
{
	static uint64	c[6] = { 0x8000800080008000ULL, rep4(29032), rep4(22970), rep4(5638), rep4(11700), rep4(32) };
	register uchar	*p;
	register long	i;

	pxor_r2r(mm5,mm5);

	for (i=8; i; i--)
	{
		p=rgb;

		gety(mm0,yuv,0);
		getuv2(mm1,yuv,64);
		getuv2(mm2,yuv,128);

		movq_r2r(mm1,mm3);	pmulhw_m2r(c[1],mm3);	paddw_r2r(mm0,mm3);	// mm3 = b
		movq_r2r(mm2,mm4);	pmulhw_m2r(c[2],mm4);	paddw_r2r(mm0,mm4);	// mm4 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm0);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm0);	// mm0 = g
		psraw_i2r(6,mm3);	psraw_i2r(6,mm4);	psraw_i2r(6,mm0);
		packuswb_r2r(mm5,mm4);	packuswb_r2r(mm5,mm3);	packuswb_r2r(mm5,mm0);
		wrgb2(p,d0,mm4,mm0,mm3,mm5,mm6);


		gety(mm0,yuv,4);
		getuv2(mm1,yuv,68);
		getuv2(mm2,yuv,132);

		movq_r2r(mm1,mm3);	pmulhw_m2r(c[1],mm3);	paddw_r2r(mm0,mm3);	// mm3 = b
		movq_r2r(mm2,mm4);	pmulhw_m2r(c[2],mm4);	paddw_r2r(mm0,mm4);	// mm4 = r
					pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm0);
					pmulhw_m2r(c[4],mm2);	psubw_r2r(mm2,mm0);	// mm0 = g
		psraw_i2r(6,mm3);	psraw_i2r(6,mm4);	psraw_i2r(6,mm0);
		packuswb_r2r(mm5,mm4);	packuswb_r2r(mm5,mm3);	packuswb_r2r(mm5,mm0);
		wrgb2(p,d0,mm4,mm0,mm3,mm5,mm6);

		yuv+=8;
		rgb+=d1;
	}
}
