
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sc.h"

#include "mmx.h"

#define cl_exp	5

#define c4(x)		( x | (x<<16) | (x<<32) | (x<<48) )
#define c4l(x)		c4( ((long long) ((x)&0xFFFF)) )
#define c1l(a,c,b,d)	( ((long long) ((a)&0xFFFF)) | (((long long) ((b)&0xFFFF))<<16) | (((long long) ((c)&0xFFFF))<<32) | (((long long) ((d)&0xFFFF))<<48) )

#define t5(x)	(x)<<5,(x)<<5,(x)<<5
#define t7(x)	(x)<<7,(x)<<7,(x)<<7

#define ldu(m,r,z)	\
			movd_m2r(m,r);		\
			punpcklbw_r2r(z,r)

#define ldu6(m,r,z)	\
			movd_m2r(m,r);		\
			punpcklbw_r2r(z,r);	\
			psllw_i2r(6,r)

#define ldu5(m,r,z)	\
			movd_m2r(m,r);		\
			punpcklbw_r2r(z,r);	\
			psllw_i2r(5,r)

#define ldu4(m,r,z)	\
			movd_m2r(m,r);		\
			punpcklbw_r2r(z,r);	\
			psllw_i2r(4,r)

#define ldu5m(m,r,z)	\
			movd_m2r(m,r);		\
			punpcklbw_m2r(z,r);	\
			psllw_i2r(5,r)


#define ldu7(m,r,z)	\
			movd_m2r(m,r);		\
			punpcklbw_r2r(z,r);	\
			psllw_i2r(7,r)

#define ldmul(m,r,c,z)	\
			movd_m2r(m,r);		\
			punpcklbw_r2r(z,r);	\
			pmullw_m2r(c,r)

#define ldmul2(ma,mb,r,c,z,t)	\
			movd_m2r(ma,r);		\
			movd_m2r(mb,t);		\
			punpcklbw_r2r(z,r);	\
			punpcklbw_r2r(z,t);	\
			paddw_r2r(t,r);		\
			pmullw_m2r(c,r)

#define ldmul2r(ma,mb,r,c,z,t)	\
			movd_m2r(ma,r);		\
			movd_m2r(mb,t);		\
			punpcklbw_r2r(z,r);	\
			punpcklbw_r2r(z,t);	\
			paddw_r2r(t,r);		\
			pmullw_r2r(c,r)

#define ldmac(m,s,c,z,t)	\
			movd_m2r(m,t);		\
			punpcklbw_r2r(z,t);	\
			pmullw_m2r(c,t);	\
			paddw_r2r(t,s)

#define ldmac2(ma,mb,s,c,z,ta,tb)	\
			movd_m2r(ma,ta);	\
			movd_m2r(mb,tb);	\
			punpcklbw_r2r(z,ta); 	\
			punpcklbw_r2r(z,tb); 	\
			paddw_r2r(tb,ta);	\
			pmullw_m2r(c,ta);	\
			paddw_r2r(ta,s)

#define ldmac2r(ma,mb,s,c,z,ta,tb)	\
			movd_m2r(ma,ta);	\
			movd_m2r(mb,tb);	\
			punpcklbw_r2r(z,ta); 	\
			punpcklbw_r2r(z,tb); 	\
			paddw_r2r(tb,ta);	\
			pmullw_r2r(c,ta);	\
			paddw_r2r(ta,s)


#ifdef SSE
#define prefetch(x)	mmx_fetch(((uchar *) (x))[80],t0)
#else
#define prefetch(x)
#endif


static void scale_1_4_hor(short *y,uchar *x,long n)
{
	long long	c[4] = { c4l(-3), c4l(28), c4l(37), c4l(-5) };

	pxor_r2r(mm7,mm7);

	ldu(x[-4],mm0,mm7);
	ldu(x[ 0],mm1,mm7);
	ldu(x[ 4],mm2,mm7);

	for (; n; n--)
	{
		ldu(x[ 8],mm3,mm7);

		movq_r2r(mm1,mm4); psllw_i2r(5,mm4);
		movq_r2m( mm4,y[0]);

		movq_r2r(mm0,mm4); pmullw_m2r(c[0],mm4);
		movq_r2r(mm1,mm5); pmullw_m2r(c[1],mm5); paddw_r2r(mm5,mm4);
		movq_r2r(mm2,mm5); psllw_i2r(3,mm5);     paddw_r2r(mm5,mm4);
		psubw_r2r(mm3,mm4);
		movq_r2m( mm4,y[4]);

		movq_r2r(mm1,mm4); paddw_r2r(mm2,mm4); pmullw_m2r(c[2],mm4);
		movq_r2r(mm2,mm5); paddw_r2r(mm3,mm5); pmullw_m2r(c[3],mm5); paddw_r2r(mm5,mm4);
		psraw_i2r(1,mm4);
		movq_r2m( mm4,y[8]);

		movq_r2r(mm3,mm4); pmullw_m2r(c[0],mm4);
		movq_r2r(mm2,mm5); pmullw_m2r(c[1],mm5); paddw_r2r(mm5,mm4);
		movq_r2r(mm1,mm5); psllw_i2r(3,mm5);     paddw_r2r(mm5,mm4);
		psubw_r2r(mm0,mm4);
		movq_r2m( mm4,y[12]);

		movq_r2r(mm1,mm0);
		movq_r2r(mm2,mm1);
		movq_r2r(mm3,mm2);

		x+=4;
		y+=16;
	}
}

static inline void scale_1_4_ver_0(uchar *y,short *x,long n)
{
	long long	o = c4l(16);

	movq_m2r( o,mm1);

	do
	{
		movq_m2r( x[0],mm0);
		paddw_r2r(mm1,mm0);
		psraw_i2r(5,mm0);
		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);
		x+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static void scale_1_4_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,long n)
{
	long long	c[3] = { c4l(28<<10), c4l(3<<10), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);

	do
	{
		movq_m2r( x1[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x0[0],mm1);	pmulhw_r2r(mm3,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	psraw_i2r(3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x3[0],mm1);	psraw_i2r(6,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm4,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_1_4_ver_2(uchar *y,short *x0,short *x1,short *x2,short *x3,long n)
{
	long long	c[2] = { c4l(5<<10), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);

	do
	{
		movq_m2r(x1[0],mm1);	paddw_m2r(x2[0],mm1);	movq_r2r(mm1,mm0);	psraw_i2r(1,mm0);
		psubw_m2r(x0[0],mm1);	psubw_m2r(x3[0],mm1);	pmulhw_r2r(mm2,mm1);	paddw_r2r(mm1,mm0);

		paddw_r2r(mm3,mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_1_4(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[4];
	register short	*tb;
	register long	i,j,u,v;

	v=px&3;
	w+=v;
	px-=v;
	u=(w+3)>>2;
	v<<=2;

	tb=((short *) tbi)+v;

	dx*=4;
	x+=4*((px>>2)+border)+((py>>2)+border-1)*dx;
	py&=3;

	for (i=0; i<4; i++)
	{
		buf[i]=tb;
		scale_1_4_hor(tb-v,x,u); x+=dx;
		tb+=4*4*u;
	}

	for (j=py; j<py+h; j++)
	{
		switch ( j&3 ) {
			case 0 : scale_1_4_ver_0(y,       buf[1],              w); y+=dy;	continue;
			case 1 : scale_1_4_ver_1(y,buf[0],buf[1],buf[2],buf[3],w); y+=dy;	continue;
			case 2 : scale_1_4_ver_2(y,buf[0],buf[1],buf[2],buf[3],w); y+=dy;	continue;
			case 3 : scale_1_4_ver_1(y,buf[3],buf[2],buf[1],buf[0],w); y+=dy;
				 tb=buf[0]; for (i=0; i<3; i++) buf[i]=buf[i+1]; buf[3]=tb;
				 scale_1_4_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
	emms();
}

static void scale_1_3_hor(short *y,uchar *x,long n)
{
	long long	c[6] = { c4l( (5)<<9 ), c4l((-20)<<9), c4l((104)<<8), c4l((49)<<9), c4l((-13)<<9), c4l((3)<<9) };

	pxor_r2r(mm7,mm7);

	ldu6(x[-8],mm0,mm7);
	ldu6(x[-4],mm1,mm7);
	ldu6(x[ 0],mm2,mm7);
	ldu6(x[ 4],mm3,mm7);
	ldu6(x[ 8],mm4,mm7);

	for (; n; n--)
	{
		pxor_r2r(mm7,mm7);
		ldu6(x[12],mm5,mm7);

		movq_r2m(mm2,y[0]);

		movq_r2r(mm0,mm7); pmulhw_m2r(c[0],mm7);
		movq_r2r(mm1,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm2,mm6); paddw_r2r(mm2,mm6); pmulhw_m2r(c[2],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm3,mm6); pmulhw_m2r(c[3],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm4,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm5,mm6); pmulhw_m2r(c[5],mm6); paddw_r2r(mm6,mm7);
		movq_r2m(mm7,y[4]);

		movq_r2r(mm5,mm7); pmulhw_m2r(c[0],mm7);
		movq_r2r(mm4,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm3,mm6); paddw_r2r(mm3,mm6); pmulhw_m2r(c[2],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm2,mm6); pmulhw_m2r(c[3],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm1,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm6,mm7);
		                   pmulhw_m2r(c[5],mm0); paddw_r2r(mm0,mm7);
		movq_r2m(mm7,y[8]);

		movq_r2r(mm1,mm0);
		movq_r2r(mm2,mm1);
		movq_r2r(mm3,mm2);
		movq_r2r(mm4,mm3);
		movq_r2r(mm5,mm4);

		x+= 4;
		y+=12;
	}
}

static inline void scale_1_3_ver_0(uchar *y,short *x,long n)
{
	long long	o = c4l(32);

	movq_m2r(o,mm1);

	do
	{
		movq_m2r( x[0],mm0);
		paddw_r2r(mm1,mm0);
		psraw_i2r(6,mm0);
		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);
		x+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static void scale_1_3_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,long n)
{
	long long	c[7] = { c4l(5<<8), c4l(20<<8), c4l(104<<8), c4l(49<<8), c4l(13<<8), c4l(3<<8), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);
	movq_m2r( c[5],mm7);

	do
	{
		movq_m2r( x0[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x1[0],mm1);	pmulhw_r2r(mm3,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm5,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x4[0],mm1);	pmulhw_r2r(mm6,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x5[0],mm1);	pmulhw_r2r(mm7,mm1);	paddw_r2r(mm1,mm0);


		paddw_m2r(c[6],mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_1_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[6];
	register short	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;
	v<<=2;

	tb=((short *) tbi)+v;

	dx*=4;
	x+=4*((px/3)+border)+((py/3)+border-2)*dx;
	py%=3;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_1_3_hor(tb-v,x,u); x+=dx;
		tb+=4*3*u;
	}

	for (; h; h--)
	{
		switch ( py ) {
			case 0 : scale_1_3_ver_0(y,              buf[2],                     w); y+=dy; py=1;	continue;
			case 1 : scale_1_3_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],w); y+=dy; py=2;	continue;
			case 2 : scale_1_3_ver_1(y,buf[5],buf[4],buf[3],buf[2],buf[1],buf[0],w); y+=dy; py=0;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_1_3_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}

	emms();
}

static void scale_1_2_hor(short *y,uchar *x,long n)
{
	long long	c[2] = { c4l( (39)<<9 ), c4l((-9)<<9) };

	pxor_r2r(mm7,mm7);

	ldu6(x[-8],mm0,mm7);
	ldu6(x[-4],mm1,mm7);
	ldu6(x[ 0],mm2,mm7);
	ldu6(x[ 4],mm3,mm7);
	ldu6(x[ 8],mm4,mm7);

	for (; n; n--)
	{
		pxor_r2r(mm7,mm7);
		ldu6(x[12],mm5,mm7);

		movq_r2r(mm2,mm7); psraw_i2r(1,mm7);	movq_r2m(mm7,y[0]);

		movq_r2r(mm2,mm7); paddw_r2r(mm3,mm7); pmulhw_m2r(c[0],mm7);
		movq_r2r(mm1,mm6); paddw_r2r(mm4,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm7);
		paddw_r2r(mm5,mm0); psraw_i2r(6,mm0);  paddw_r2r(mm0,mm7);
		movq_r2m(mm7,y[4]);

		movq_r2r(mm1,mm0);
		movq_r2r(mm2,mm1);
		movq_r2r(mm3,mm2);
		movq_r2r(mm4,mm3);
		movq_r2r(mm5,mm4);

		x+=4;
		y+=8;
	}

/*
	for (; n; n--)
	{
		y[0]=x[0]<<5;
		y[1]=x[1]<<5;
		y[2]=x[2]<<5;
		y+=4;
		y[0]=(39*(x[0]+x[4])-9*(x[-4]+x[8])+2*(x[-8]+x[12]))>>1;
		y[1]=(39*(x[1]+x[5])-9*(x[-3]+x[9])+2*(x[-7]+x[13]))>>1;
		y[2]=(39*(x[2]+x[6])-9*(x[-2]+x[10])+2*(x[-6]+x[14]))>>1;
		x+=4;
		y+=4;
	}
*/
}

static inline void scale_1_2_ver_0(uchar *y,short *x,long n)
{
	long long	o = c4l(16);

	movq_m2r( o,mm1);

	do
	{
		movq_m2r( x[0],mm0);
		paddw_r2r(mm1,mm0);
		psraw_i2r(5,mm0);
		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);
		x+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static void scale_1_2_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,long n)
{
	long long	c[3] = { c4l(39<<9), c4l(9<<9), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);

	do
	{
		movq_m2r( x2[0],mm0);	paddw_m2r(x3[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x4[0],mm1);	pmulhw_r2r(mm3,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x5[0],mm1);	psraw_i2r(6,mm1);	paddw_r2r(mm1,mm0);

		paddw_r2r(mm4,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4;
		y+=4;
		n--;
	}
	while ( n );
}


void scale_1_2(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[6];
	register short	*tb;
	register long	i,u,v;

	v=px&1;
	w+=v;
	px-=v;
	u=(w+1)>>1;
	v<<=2;

	tb=((short *) tbi)+v;

	dx*=4;
	x+=4*((px>>1)+border)+((py>>1)+border-2)*dx;
	px&=1;
	py&=1;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_1_2_hor(tb-v,x,u); x+=dx;
		tb+=4*w;
	}

	for (; h; h--)
	{
		switch ( py ) {
			case 0 : scale_1_2_ver_0(y,              buf[2],                     w); y+=dy; py=1;	continue;
			case 1 : scale_1_2_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],w); y+=dy; py=0;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_1_2_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
	emms();
}


static void scale_2_3_hor(short *y,uchar *x,long n)
{
	long long	c[6] = { c4l( (5)<<9 ), c4l((-20)<<9), c4l((104)<<8), c4l((49)<<9), c4l((-13)<<9), c4l((3)<<9) };

	pxor_r2r(mm7,mm7);

	ldu6(x[-8],mm0,mm7);
	ldu6(x[-4],mm1,mm7);
	ldu6(x[ 0],mm2,mm7);
	ldu6(x[ 4],mm3,mm7);
	ldu6(x[ 8],mm4,mm7);

	for (; n; n--)
	{
		pxor_r2r(mm7,mm7);
		ldu6(x[12],mm5,mm7);

		movq_r2m(mm2,y[0]);

		movq_r2r(mm5,mm7); pmulhw_m2r(c[0],mm7);
		movq_r2r(mm4,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm3,mm6); paddw_r2r(mm3,mm6); pmulhw_m2r(c[2],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm2,mm6); pmulhw_m2r(c[3],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm1,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm0,mm6); pmulhw_m2r(c[5],mm6); paddw_r2r(mm6,mm7);
		movq_r2m(mm7,y[4]);

		movq_r2r(mm1,mm7); pmulhw_m2r(c[0],mm7);
		movq_r2r(mm2,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm3,mm6); paddw_r2r(mm3,mm6); pmulhw_m2r(c[2],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm4,mm6); pmulhw_m2r(c[3],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm5,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm6,mm7);

		movq_r2r(mm2,mm0);
		movq_r2r(mm3,mm1);
		movq_r2r(mm4,mm2);
		movq_r2r(mm5,mm3);

		pxor_r2r(mm6,mm6);
		ldu6(x[16],mm4,mm6);

		movq_r2r(mm4,mm6); pmulhw_m2r(c[5],mm6); paddw_r2r(mm6,mm7);
		movq_r2m(mm7,y[8]);

		x+= 8;
		y+=12;
	}

/*
	for (; n; n--)
	{
		y[0]=x[0]<<6;
		y[1]=x[1]<<6;
		y[2]=x[2]<<6;
		y+=4;

		y[0]=(3*x[-8]-13*x[-4]+49*x[0]+104*x[4]-20*x[8]+5*x[12])>>1;
		y[1]=(3*x[-7]-13*x[-3]+49*x[1]+104*x[5]-20*x[9]+5*x[13])>>1;
		y[2]=(3*x[-6]-13*x[-2]+49*x[2]+104*x[6]-20*x[10]+5*x[14])>>1;
		x+=4;
		y+=4;


		y[0]=(5*x[-8]-20*x[-4]+104*x[0]+49*x[4]-13*x[8]+3*x[12])>>1;
		y[1]=(5*x[-7]-20*x[-3]+104*x[1]+49*x[5]-13*x[9]+3*x[13])>>1;
		y[2]=(5*x[-6]-20*x[-2]+104*x[2]+49*x[6]-13*x[10]+3*x[14])>>1;
		x+=4;
		y+=4;
	}
*/
}

void scale_2_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[6];
	register short	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;

	v<<=2;

	tb=((short *) tbi)+v;

	dx*=4;
	px*=2;
	py*=2;
	x+=4*(px/3+border)+(py/3+border-2)*dx;
	px%=3;
	py%=3;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_2_3_hor(tb-v,x,u); x+=dx;
		tb+=4*3*u;
	}

	for (; h; h--)
	{
		switch ( py ) {
			case 0 : scale_1_3_ver_0(y,              buf[2],                     w); y+=dy; py=2;
				 continue;
			case 1 : scale_1_3_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],w); y+=dy; py=0;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_2_3_hor(tb-v,x,u); x+=dx;
				 continue;
			case 2 : scale_1_3_ver_1(y,buf[5],buf[4],buf[3],buf[2],buf[1],buf[0],w); y+=dy; py=1;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_2_3_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
	emms();
}

void scale_1_1(int *tb,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	dx*=4;
	x+=4*(px+border)+(py+border)*dx;

	do
	{
		memcpy(y,x,4*w);
		x+=dx;
		y+=dy;
		h--;
	}
	while ( h );	
}

static void scale_6_5_hor(short *y,uchar *x,long n)
{
	long long	c[8] = { c4l((106)<<8), c4l(( -5)<<8),
				 c4l((101)<<8), c4l(( 38)<<8), c4l(( -9)<<8),
				 c4l(( 84)<<8), c4l(( 62)<<8), c4l((-10)<<8),
				};

	pxor_r2r(mm7,mm7);

	ldu6(x[-8],mm0,mm7);
	ldu6(x[-4],mm1,mm7);
	ldu6(x[ 0],mm2,mm7);
	ldu6(x[ 4],mm3,mm7);

	for (; n; n--)
	{
		pxor_r2r(mm7,mm7);
		ldu6(x[ 8],mm4,mm7);

		movq_r2r(mm2,mm7); pmulhw_m2r(c[0],mm7);
		movq_r2r(mm1,mm6); paddw_r2r(mm3,mm6); psraw_i2r(4,mm6); paddw_r2r(mm6,mm7);
		paddw_r2r(mm4,mm0); pmulhw_m2r(c[1],mm0); paddw_r2r(mm0,mm7);
		movq_r2m(mm7,y[0]);

		pxor_r2r(mm7,mm7);
		ldu6(x[12],mm5,mm7);
		ldu6(x[16],mm0,mm7);

		movq_r2r(mm3,mm7); pmulhw_m2r(c[2],mm7);
		movq_r2r(mm4,mm6); pmulhw_m2r(c[3],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm5,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm6,mm7);
		psraw_i2r(7,mm1); psubw_r2r(mm1,mm7);
		movq_r2m(mm7,y[4]);


		movq_r2r(mm4,mm1); pmulhw_m2r(c[5],mm1);
		movq_r2r(mm5,mm6); pmulhw_m2r(c[6],mm6); paddw_r2r(mm6,mm1);
		movq_r2r(mm0,mm2); pmulhw_m2r(c[7],mm2); paddw_r2r(mm2,mm1);
		psraw_i2r(5,mm3); psubw_r2r(mm3,mm1);
		movq_r2m(mm1,y[8]);

		pxor_r2r(mm7,mm7);
		ldu6(x[20],mm1,mm7);
		ldu6(x[24],mm2,mm7);
		ldu6(x[28],mm3,mm7);

		movq_r2r(mm0,mm7); pmulhw_m2r(c[5],mm7); paddw_r2r(mm7,mm6);
		                   pmulhw_m2r(c[7],mm4); paddw_r2r(mm4,mm6);
		movq_r2r(mm1,mm7); psraw_i2r(5,mm7); psubw_r2r(mm7,mm6);
		movq_r2m(mm6,y[12]);


		movq_r2r(mm1,mm7); pmulhw_m2r(c[2],mm7);
		movq_r2r(mm0,mm6); pmulhw_m2r(c[3],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm5,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm6,mm7);
		movq_r2r(mm3,mm6); psraw_i2r(7,mm6); psubw_r2r(mm6,mm7);
		movq_r2m(mm7,y[16]);

		x+=6*4;
		y+=5*4;
	}

/*
	for (; n; n--)
	{
		y[0]=(106*x[0]+16*(x[-4]+x[4])-5*(x[-8]+x[8]))>>2;
		y[1]=(106*x[1]+16*(x[-3]+x[5])-5*(x[-7]+x[9]))>>2;
		y[2]=(106*x[2]+16*(x[-2]+x[6])-5*(x[-6]+x[10]))>>2;
		x+=4;
		y+=4;

		y[0]=(-2*x[-8]+101*x[0]+38*x[4]-9*x[8])>>2;
		y[1]=(-2*x[-7]+101*x[1]+38*x[5]-9*x[9])>>2;
		y[2]=(-2*x[-6]+101*x[2]+38*x[6]-9*x[10])>>2;
		x+=4;
		y+=4;

		y[0]=(-8*x[-4]+84*x[0]+62*x[4]-10*x[8])>>2;
		y[1]=(-8*x[-3]+84*x[1]+62*x[5]-10*x[9])>>2;
		y[2]=(-8*x[-2]+84*x[2]+62*x[6]-10*x[10])>>2;
		x+=4;
		y+=4;

		y[0]=(-10*x[-4]+62*x[0]+84*x[4]-8*x[8])>>2;
		y[1]=(-10*x[-3]+62*x[1]+84*x[5]-8*x[9])>>2;
		y[2]=(-10*x[-2]+62*x[2]+84*x[6]-8*x[10])>>2;
		x+=4;
		y+=4;

		y[0]=(-9*x[-4]+38*x[0]+101*x[4]-2*x[12])>>2;
		y[1]=(-9*x[-3]+38*x[1]+101*x[5]-2*x[13])>>2;
		y[2]=(-9*x[-2]+38*x[2]+101*x[6]-2*x[14])>>2;
		x+=8;
		y+=4;
	}
*/
}

static inline void scale_6_5_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,long n)
{
	long long	c[3] = { c4l(106<<8), c4l(5<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);

	do
	{
		movq_m2r( x2[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x3[0],mm1);	psraw_i2r(4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x4[0],mm1);	pmulhw_r2r(mm3,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm4,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_6_5_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,long n)
{
	long long	c[4] = { c4l(101<<8), c4l(38<<8), c4l(9<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x1[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x2[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	psraw_i2r(7,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_6_5_ver_2(uchar *y,short *x0,short *x1,short *x2,short *x3,long n)
{
	long long	c[4] = { c4l(84<<8), c4l(62<<8), c4l(10<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x1[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x2[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	psraw_i2r(5,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_6_5(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[6];
	register short	*tb;
	register long	i,u,v;

	v=px%5;
	w+=v;
	px-=v;
	u=(w+4)/5;
	v<<=2;

	tb=((short *) tbi)+v;

	dx*=4;
	px*=6;
	py*=6;
	x+=4*((px/5)+border)+((py/5)+border-2)*dx;
	py%=5;

	for (i=0; i<5; i++)
	{
		buf[i]=tb;
		scale_6_5_hor(tb-v,x,u); x+=dx;
		tb+=4*w;
	}
	buf[5]=tb;

	for (; h; h--)
	{
		scale_6_5_hor(tb-v,x,u); x+=dx;

		switch ( py ) {
			case 0 : scale_6_5_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],w);	y+=dy; py=1;  break;
			case 1 : scale_6_5_ver_1(y,buf[0],buf[2],buf[3],buf[4],w);		y+=dy; py=2;  break;
			case 2 : scale_6_5_ver_2(y,buf[1],buf[2],buf[3],buf[4],w);		y+=dy; py=3;  break;
			case 3 : scale_6_5_ver_2(y,buf[4],buf[3],buf[2],buf[1],w);		y+=dy; py=4;  break;
			case 4 : scale_6_5_ver_1(y,buf[5],buf[3],buf[2],buf[1],w);		y+=dy; py=0;  break;
		}

		tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;

		if ( !py )
		{
			scale_6_5_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
		}
	}
	emms();
}


static void scale_4_3_hor(short *y,uchar *x,long n)
{
	long long	c[6] = { c4l(( 96)<<8), c4l(( 25)<<8), c4l((-11)<<8),
				 c4l(( -5)<<8), c4l(( 85)<<8), c4l(( 58)<<8)
				};

	pxor_r2r(mm7,mm7);

	ldu6(x[-12],mm0,mm7);
	ldu6(x[ -8],mm1,mm7);
	ldu6(x[ -4],mm2,mm7);
	ldu6(x[  0],mm3,mm7);
	ldu6(x[  4],mm4,mm7);
	ldu6(x[  8],mm5,mm7);

	for (; n; n--)
	{
		pxor_r2r(mm7,mm7);
		ldu6(x[12],mm6,mm7);

		paddw_r2r(mm6,mm0); psraw_i2r(7,mm0);
		movq_r2r(mm3,mm7);                     pmulhw_m2r(c[0],mm7); paddw_r2r(mm7,mm0);
		movq_r2r(mm2,mm7); paddw_r2r(mm4,mm7); pmulhw_m2r(c[1],mm7); paddw_r2r(mm7,mm0);
		movq_r2r(mm1,mm7); paddw_r2r(mm6,mm7); pmulhw_m2r(c[2],mm7); paddw_r2r(mm7,mm0);
		movq_r2m(mm0,y[0]);


		psraw_i2r(8,mm1);
		movq_r2r(mm2,mm7); pmulhw_m2r(c[3],mm7); paddw_r2r(mm7,mm1);
		movq_r2r(mm4,mm7); pmulhw_m2r(c[4],mm7); paddw_r2r(mm7,mm1);
		movq_r2r(mm5,mm7); pmulhw_m2r(c[5],mm7); paddw_r2r(mm7,mm1);
		movq_r2r(mm6,mm2); pmulhw_m2r(c[2],mm6); paddw_r2r(mm6,mm1);
		movq_r2m(mm1,y[4]);

		pxor_r2r(mm7,mm7);
		movq_r2r(mm4,mm0);
		movq_r2r(mm5,mm1);
		ldu6(x[16],mm3,mm7);
		ldu6(x[20],mm4,mm7);
		ldu6(x[24],mm5,mm7);

		movq_r2r(mm5,mm6); psraw_i2r(8,mm6);
		movq_r2r(mm4,mm7); pmulhw_m2r(c[3],mm7); paddw_r2r(mm7,mm6);
		movq_r2r(mm2,mm7); pmulhw_m2r(c[4],mm7); paddw_r2r(mm7,mm6);
		movq_r2r(mm1,mm7); pmulhw_m2r(c[5],mm7); paddw_r2r(mm7,mm6);
		movq_r2r(mm0,mm7); pmulhw_m2r(c[2],mm7); paddw_r2r(mm7,mm6);
		movq_r2m(mm6,y[8]);

		x+=4*4;
		y+=3*4;
	}

/*
	for (; n; n--)
	{
		y[0]=(96*x[0]+25*(x[-4]+x[4])-11*(x[-8]+x[8])+2*(x[-12]+x[12]))>>2;
		y[1]=(96*x[1]+25*(x[-3]+x[5])-11*(x[-7]+x[9])+2*(x[-11]+x[13]))>>2;
		y[2]=(96*x[2]+25*(x[-2]+x[6])-11*(x[-6]+x[10])+2*(x[-10]+x[14]))>>2;
		x+=4;
		y+=4;

		y[0]=(x[-12]-5*x[-8]+85*x[0]+58*x[4]-11*x[8])>>2;
		y[1]=(x[-11]-5*x[-7]+85*x[1]+58*x[5]-11*x[9])>>2;
		y[2]=(x[-10]-5*x[-6]+85*x[2]+58*x[6]-11*x[10])>>2;
		x+=4;
		y+=4;

		y[0]=(-11*x[-4]+58*x[0]+85*x[4]-5*x[12]+x[16])>>2;
		y[1]=(-11*x[-3]+58*x[1]+85*x[5]-5*x[13]+x[17])>>2;
		y[2]=(-11*x[-2]+58*x[2]+85*x[6]-5*x[14]+x[18])>>2;

		x+=8;
		y+=4;
	}
*/
}

static inline void scale_4_3_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,long n)
{
	long long	c[4] = { c4l(96<<8), c4l(25<<8), c4l(11<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x3[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x4[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x6[0],mm1);	psraw_i2r(7,mm1);	paddw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_4_3_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,long n)
{
	long long	c[5] = { c4l(85<<8), c4l(58<<8), c4l(11<<8), c4l(5<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);

	do
	{
		movq_m2r( x2[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x4[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	psraw_i2r(8,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	pmulhw_r2r(mm5,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm6,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_4_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[8];
	register short	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;
	v>>=2;

	tb=((short *) tbi)+v;

	dx*=4;
	px*=4;
	py*=4;
	x+=4*((px/3)+border)+((py/3)+border-3)*dx;
	py%=3;

	for (i=0; i<7; i++)
	{
		buf[i]=tb;
		scale_4_3_hor(tb-v,x,u); x+=dx;
		tb+=4*3*u;
	}
	buf[7]=tb;

	for (; h; h--)
	{
		scale_4_3_hor(tb-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_4_3_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],w); y+=dy; py=1;  break;
			case 1 : scale_4_3_ver_1(y,buf[0],buf[1],       buf[3],buf[4],buf[5],       w); y+=dy; py=2;  break;
			case 2 : scale_4_3_ver_1(y,buf[7],buf[6],       buf[4],buf[3],buf[2],       w); y+=dy; py=0;  break;
		}

		tb=buf[0]; for (i=0; i<7; i++) buf[i]=buf[i+1]; buf[7]=tb;

		if ( !py )
		{
			scale_4_3_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<7; i++) buf[i]=buf[i+1]; buf[7]=tb;
		}
	}
	emms();
}


static void scale_3_2_hor(short *y,uchar *x,long n)
{
	long long	c[4] = { c4l(( 86)<<8), c4l(( 31)<<8), c4l((-10)<<8),
				 c4l(( 17)<<10)
				};

	pxor_r2r(mm7,mm7);

	ldu6(x[-8],mm0,mm7);
	ldu6(x[-4],mm1,mm7);
	ldu6(x[ 0],mm2,mm7);
	ldu6(x[ 4],mm3,mm7);
	ldu6(x[ 8],mm4,mm7);

	for (; n; n--)
	{
		ldu6(x[ 8],mm4,mm7);

		                   paddw_r2r(mm4,mm0); pmulhw_m2r(c[2],mm0);
		movq_r2r(mm2,mm6);                     pmulhw_m2r(c[0],mm6); paddw_r2r(mm6,mm0);
		movq_r2r(mm1,mm6); paddw_r2r(mm3,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm0);
		movq_r2m(mm0,y[0]);

		movq_r2r(mm3,mm6); paddw_r2r(mm4,mm6); pmulhw_m2r(c[3],mm6);
		psraw_i2r(6,mm1); psubw_r2r(mm1,mm6);
		movq_r2r(mm3,mm0);
		movq_r2r(mm4,mm1);
		ldu6(x[12],mm2,mm7);
		ldu(x[16],mm3,mm7); psubw_r2r(mm3,mm6);
		psllw_i2r(6,mm3);
		movq_r2m(mm6,y[4]);

		x+=3*4;
		y+=2*4;
	}

/*
	for (; n; n--)
	{
		y[0]=(86*x[0]+31*(x[-4]+x[4])-10*(x[-8]+x[8]))>>2;
		y[1]=(86*x[1]+31*(x[-3]+x[5])-10*(x[-7]+x[9]))>>2;
		y[2]=(86*x[2]+31*(x[-2]+x[6])-10*(x[-6]+x[10]))>>2;
		x+=4;
		y+=4;

		y[0]=17*(x[0]+x[4])-x[-8]-x[12];
		y[1]=17*(x[1]+x[5])-x[-7]-x[13];
		y[2]=17*(x[2]+x[6])-x[-6]-x[14];
		x+=8;
		y+=4;
	}
*/
}

static inline void scale_3_2_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,long n)
{
	long long	c[4] = { c4l(86<<8), c4l(31<<8), c4l(10<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x2[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x3[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x4[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_3_2_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,long n)
{
	long long	c[2] = { c4l(17<<10), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);

	do
	{
		movq_m2r( x1[0],mm0);	paddw_m2r(x2[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x3[0],mm1);	psraw_i2r(6,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm3,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4;
		y+=4;
		n--;
	}
	while ( n );
}


void scale_3_2(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[5];
	register short	*tb;
	register long	i,u,v;

	v=px&1;
	w+=v;
	px-=v;
	u=(w+1)/2;
	v<<=2;

	tb = ((short *) tbi)+v;

	dx*=4;
	px*=3;
	py*=3;
	x+=4*((px>>1)+border)+((py>>1)+border-2)*dx;
	py&=1;

	for (i=0; i<4; i++)
	{
		buf[i]=tb;
		scale_3_2_hor(tb-v,x,u); x+=dx;
		tb+=4*2*u;
	}
	buf[4]=tb;

	for (; h; h--)
	{
		scale_3_2_hor(tb-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_3_2_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],w); y+=dy; py=1;  break;
			case 1 : scale_3_2_ver_1(y,buf[1],buf[2],buf[3],buf[4]       ,w); y+=dy; py=0;  break;
		}

		tb=buf[0]; for (i=0; i<4; i++) buf[i]=buf[i+1]; buf[4]=tb;

		if ( !py )
		{
			scale_3_2_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<4; i++) buf[i]=buf[i+1]; buf[4]=tb;
		}
	}
	emms();
}


static void scale_5_3_hor(short *y,uchar *x,long n)
{
	long long	c[7] = { c4l(( 78)<<8), c4l(( 34)<<8), c4l(( -7)<<8),
				 c4l(( -5)<<8), c4l(( 55)<<8), c4l(( 71)<<8), c4l(( 14)<<8)
				};

	pxor_r2r(mm7,mm7);

	ldu6(x[-12],mm0,mm7);
	ldu6(x[- 8],mm1,mm7);
	ldu6(x[- 4],mm2,mm7);
	ldu6(x[  0],mm3,mm7);
	ldu6(x[  4],mm4,mm7);

	for (; n; n--)
	{
		pxor_r2r(mm7,mm7);
		ldu6(x[ 8],mm5,mm7);
		ldu6(x[12],mm6,mm7);

		paddw_r2r(mm5,mm1); pmulhw_m2r(c[2],mm1);
		paddw_r2r(mm6,mm0); psraw_i2r(7,mm0); psubw_r2r(mm0,mm1);
		pmulhw_m2r(c[0],mm3); paddw_r2r(mm3,mm1);
		movq_r2r(mm2,mm0); paddw_r2r(mm4,mm0); pmulhw_m2r(c[1],mm0); paddw_r2r(mm0,mm1);
		movq_r2m(mm1,y[0]);


		pmulhw_m2r(c[3],mm2);
		movq_r2r(mm4,mm3); pmulhw_m2r(c[4],mm3); paddw_r2r(mm2,mm3);
		movq_r2r(mm5,mm0); pmulhw_m2r(c[5],mm5); paddw_r2r(mm5,mm3);
		movq_r2r(mm6,mm1); pmulhw_m2r(c[6],mm6); paddw_r2r(mm6,mm3);

		ldu6(x[16],mm2,mm7);

		movq_r2r(mm2,mm5); pmulhw_m2r(c[2],mm5); paddw_r2r(mm5,mm3);
		movq_r2m(mm3,y[4]);


		pmulhw_m2r(c[2],mm4);
		movq_r2r(mm0,mm6); pmulhw_m2r(c[6],mm6); paddw_r2r(mm6,mm4);
		movq_r2r(mm1,mm6); pmulhw_m2r(c[5],mm6); paddw_r2r(mm6,mm4);
		movq_r2r(mm2,mm6); pmulhw_m2r(c[4],mm6); paddw_r2r(mm4,mm6);

		ldu6(x[24],mm3,mm7);
		movq_r2r(mm3,mm4); pmulhw_m2r(c[3],mm3); paddw_r2r(mm3,mm6);
		movq_r2m(mm6,y[8]);

		ldu6(x[20],mm3,mm7);

		x+=5*4;
		y+=3*4;
	}
/*
	for (; n; n--)
	{
		y[0]=(78*x[0]+34*(x[-4]+x[4])-7*(x[-8]+x[8])-2*(x[-12]+x[12]))>>2;
		y[1]=(78*x[1]+34*(x[-3]+x[5])-7*(x[-7]+x[9])-2*(x[-11]+x[13]))>>2;
		y[2]=(78*x[2]+34*(x[-2]+x[6])-7*(x[-6]+x[10])-2*(x[-10]+x[14]))>>2;
		x+=4;
		y+=4;

		y[0]=(-5*x[-8]+55*x[0]+71*x[4]+14*x[8]-7*x[12])>>2;
		y[1]=(-5*x[-7]+55*x[1]+71*x[5]+14*x[9]-7*x[13])>>2;
		y[2]=(-5*x[-6]+55*x[2]+71*x[6]+14*x[10]-7*x[14])>>2;
		x+=8;
		y+=4;

		y[0]=(-7*x[-8]+14*x[-4]+71*x[0]+55*x[4]-5*x[12])>>2;
		y[1]=(-7*x[-7]+14*x[-3]+71*x[1]+55*x[5]-5*x[13])>>2;
		y[2]=(-7*x[-6]+14*x[-2]+71*x[2]+55*x[6]-5*x[14])>>2;
		x+=8;
		y+=4;
	}
*/
}

static inline void scale_5_3_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,long n)
{
	long long	c[4] = { c4l(78<<8), c4l(34<<8), c4l(7<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x3[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x4[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x6[0],mm1);	psraw_i2r(7,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_5_3_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,long n)
{
	long long	c[6] = { c4l(14<<8), c4l(7<<8), c4l(71<<8), c4l(55<<8), c4l(5<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);
	movq_m2r( c[5],mm7);

	do
	{
		movq_m2r( x1[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x0[0],mm1);	pmulhw_r2r(mm3,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm5,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x4[0],mm1);	pmulhw_r2r(mm6,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm7,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_5_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[7];
	register short	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;
	v<<=2;

	tb=((short *) tbi)+v;

	dx*=4;
	px*=5;
	py*=5;
	x+=4*((px/3)+border)+((py/3)+border-3)*dx;
	py%=3;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_5_3_hor(tb-v,x,u); x+=dx;
		tb+=4*3*u;
	}
	buf[6]=tb;

	for (; h; h--)
	{
		scale_5_3_hor(tb-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_5_3_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],w); y+=dy; py=2;  break;
			case 1 : scale_5_3_ver_1(y,buf[1],buf[2],buf[3],buf[4],buf[6],w);		y+=dy; py=0;  break;
			case 2 : scale_5_3_ver_1(y,buf[6],buf[5],buf[4],buf[3],buf[1],w);		y+=dy; py=1;  break;
		}

		tb=buf[0]; for (i=0; i<6; i++) buf[i]=buf[i+1]; buf[6]=tb;

		if ( py!=2 )
		{
			scale_5_3_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<6; i++) buf[i]=buf[i+1]; buf[6]=tb;
		}
	}
	emms();
}

static void scale_2_1_hor(short *y,uchar *x,long n)
{
	long long	c[2] = { c4l(( 19)<<9), c4l(( -3)<<9) };

	pxor_r2r(mm7,mm7);

	ldu6(x[-12],mm0,mm7);
	ldu6(x[- 4],mm2,mm7);
	ldu6(x[  4],mm4,mm7);

	for (; n; n--)
	{
		ldu4(x[ 0],mm3,mm7);
		ldu6(x[12],mm6,mm7);
		paddw_r2r(mm6,mm0); pmulhw_m2r(c[1],mm0);
		paddw_r2r(mm3,mm0);
		movq_r2r(mm2,mm1); paddw_r2r(mm4,mm1); pmulhw_m2r(c[0],mm1); paddw_r2r(mm1,mm0);
		movq_r2m(mm0,y[0]);
		movq_r2r(mm4,mm0);
		ldu4(x[ 8],mm5,mm7);
		paddw_r2r(mm6,mm4); pmulhw_m2r(c[0],mm4); paddw_r2r(mm4,mm5);
		ldu6(x[20],mm4,mm7);
		paddw_r2r(mm4,mm2); pmulhw_m2r(c[1],mm2); paddw_r2r(mm2,mm5);
		movq_r2r(mm6,mm2);
		movq_r2m(mm5,y[8]);
		x+=16;
		y+=16;
	}
}



static inline void scale_2_1_ver(uchar *y,uchar *x0,uchar *x1,uchar *x2,uchar *x3,long n)
{
	long long	c[3] = { c4l(19<<10), c4l(3<<10), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);

	do
	{
		movq_m2r( x1[8],mm0);	psraw_i2r(1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x2[0],mm1);	pmulhw_r2r(mm2,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x3[0],mm1);	pmulhw_r2r(mm3,mm1);	psubw_r2r(mm1,mm0);
		paddw_r2r(mm4,mm0);
		psraw_i2r(5,mm0);
		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);
		x0+=16; x1+=16; x2+=16; x3+=16;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_2_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register uchar	*tb0, *tb1,*tb2,*tb3, *ttb;
	register long	i,u;

	dx*=4;
	x+=4*(2*px+border)+(2*py+border-3)*dx;

	u=(w+1)>>1;

	tb0=(uchar *) tbi;	for (i=0; i<16; i+=8) { scale_2_1_hor((short *) (tb0+i),x,u); x+=dx; }
	tb1=tb0+16*2*u;		for (i=0; i<16; i+=8) { scale_2_1_hor((short *) (tb1+i),x,u); x+=dx; }
	tb2=tb1+16*2*u;		for (i=0; i<16; i+=8) { scale_2_1_hor((short *) (tb2+i),x,u); x+=dx; }
	tb3=tb2+16*2*u;

	do
	{
		scale_2_1_hor((short *) (tb3  ),x,u); x+=dx;
		scale_2_1_hor((short *) (tb3+8),x,u); x+=dx;
		scale_2_1_ver(y,tb0,tb1,tb2,tb3,w); y+=dy;
		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;
		h--;
	}
	while ( h );

	emms();
}

static void scale_9_4_hor(short *y,uchar *x,long n)
{
	long long	c[10]= { c4l((  9)<<7), c4l(( 73)<<7), c4l((114)<<7),
				 c4l(( 56)<<7), c4l((110)<<7), c4l(( 89)<<7), c4l(( 22)<<7),
				 c4l(( -6)<<7), c4l(( 38)<<7), c4l((102)<<7),
				};
	long long	t0,t1,t2,zm;

	prefetch(x-16);

	pxor_r2r(mm7,mm7);
	movq_r2m(mm7,zm);

	ldu5(x[-16],mm0,mm7); movq_r2m(mm0,t0);
	ldu5(x[-12],mm1,mm7); movq_r2m(mm1,t1);
	ldu5(x[- 8],mm2,mm7); movq_r2m(mm2,t2);
	ldu5(x[- 4],mm0,mm7);
	ldu5(x[  0],mm1,mm7);

	for (; n; n--)
	{
		prefetch(x+16);

		pxor_r2r(mm7,mm7);
		ldu5(x[  4],mm2,mm7);
		ldu5(x[  8],mm3,mm7);
		ldu5(x[ 12],mm4,mm7);
		ldu5(x[ 16],mm5,mm7);

		movq_m2r(t2,mm7); paddw_r2r(mm3,mm7); psubw_r2r(mm4,mm7);
		movq_m2r(t1,mm6); psubw_r2r(mm6,mm7); pmulhw_m2r(c[0],mm7);
		movq_m2r(t0,mm6); paddw_r2r(mm5,mm6); psraw_i2r(8,mm6); psubw_r2r(mm6,mm7);
		movq_r2r(mm0,mm6); paddw_r2r(mm2,mm6); pmulhw_m2r(c[1],mm6); paddw_r2r(mm6,mm7);
		pmulhw_m2r(c[2],mm1); paddw_r2r(mm1,mm7);
		movq_r2m(mm7,y[0]);


		movq_r2r(mm2,mm1); pmulhw_m2r(c[3],mm1);
		psraw_i2r(6,mm0); psubw_r2r(mm0,mm1);
		movq_r2r(mm3,mm0); pmulhw_m2r(c[4],mm0); paddw_r2r(mm0,mm1);
		movq_r2r(mm4,mm0); pmulhw_m2r(c[5],mm0); paddw_r2r(mm0,mm1);
		movq_r2r(mm5,mm0); pmulhw_m2r(c[6],mm0); paddw_r2r(mm0,mm1);

		ldu5m(x[20],mm6,zm);
		ldu5m(x[24],mm7,zm);

		movq_r2r(mm6,mm0); pmulhw_m2r(c[0],mm0); psubw_r2r(mm0,mm1);
		movq_r2r(mm7,mm0); psraw_i2r(7,mm0); psubw_r2r(mm0,mm1);
		movq_r2m(mm1,y[4]);



		ldu5m(x[28],mm0,zm);
		ldu5m(x[32],mm1,zm);

		paddw_r2r(mm3,mm2); paddw_r2r(mm0,mm2); paddw_r2r(mm1,mm2); pmulhw_m2r(c[7],mm2);
		movq_r2r(mm4,mm3); paddw_r2r(mm7,mm3); pmulhw_m2r(c[8],mm3); paddw_r2r(mm3,mm2);
		movq_r2r(mm5,mm3); paddw_r2r(mm6,mm3); pmulhw_m2r(c[9],mm3); paddw_r2r(mm3,mm2);
		movq_r2m(mm2,y[8]);



		movq_r2m(mm6,t0);
		movq_r2m(mm7,t1);
		movq_r2m(mm0,t2);

		pmulhw_m2r(c[6],mm6);
		pmulhw_m2r(c[0],mm5); psubw_r2r(mm5,mm6);
		psraw_i2r(7,mm4); psubw_r2r(mm4,mm6);
		pmulhw_m2r(c[5],mm7); paddw_r2r(mm7,mm6);
		pmulhw_m2r(c[4],mm0); paddw_r2r(mm0,mm6);
		movq_r2r(mm1,mm0); pmulhw_m2r(c[3],mm1); paddw_r2r(mm1,mm6);

		ldu5m(x[36],mm2,zm);

		movq_r2r(mm2,mm1); psraw_i2r(6,mm2); psubw_r2r(mm2,mm6);
		movq_r2m(mm6,y[12]);

		x+=9*4;
		y+=4*4;
	}

/*
	for (; n; n--)
	{
		y[0]=(114*x[0]+73*(x[-4]+x[4])+9*(x[-8]+x[ 8]-x[-12]-x[12])-2*(x[-16]+x[16]))>>4;
		y[1]=(114*x[1]+73*(x[-3]+x[5])+9*(x[-7]+x[ 9]-x[-11]-x[13])-2*(x[-15]+x[17]))>>4;
		y[2]=(114*x[2]+73*(x[-2]+x[6])+9*(x[-6]+x[10]-x[-10]-x[14])-2*(x[-14]+x[18]))>>4;
		x+=8;
		y+=4;

		y[0]=(-8*x[-12]+56*x[-4]+110*x[0]+89*x[4]+22*x[8]-9*x[12]-4*x[16])>>4;
		y[1]=(-8*x[-11]+56*x[-3]+110*x[1]+89*x[5]+22*x[9]-9*x[13]-4*x[17])>>4;
		y[2]=(-8*x[-10]+56*x[-2]+110*x[2]+89*x[6]+22*x[10]-9*x[14]-4*x[18])>>4;
		x+=8;
		y+=4;

		y[0]=(102*(x[0]+x[4])+38*(x[-4]+x[8])-6*(x[-12]+x[-8]+x[12]+x[16]))>>4;
		y[1]=(102*(x[1]+x[5])+38*(x[-3]+x[9])-6*(x[-11]+x[-7]+x[13]+x[17]))>>4;
		y[2]=(102*(x[2]+x[6])+38*(x[-2]+x[10])-6*(x[-10]+x[-6]+x[14]+x[18]))>>4;
		x+=8;
		y+=4;

		y[0]=(-4*x[-12]-9*x[-8]+22*x[-4]+89*x[0]+110*x[4]+56*x[8]-8*x[16])>>4;
		y[1]=(-4*x[-11]-9*x[-7]+22*x[-3]+89*x[1]+110*x[5]+56*x[9]-8*x[17])>>4;
		y[2]=(-4*x[-10]-9*x[-6]+22*x[-2]+89*x[2]+110*x[6]+56*x[10]-8*x[18])>>4;
		x+=12;
		y+=4;
	}
*/
}


static inline void scale_9_4_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,short *x7,short *x8,long n)
{
	long long	c[4] = { c4l(114<<8), c4l(73<<8), c4l(9<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x4[0],mm0);
		pmulhw_r2r(mm2,mm0);

		movq_m2r( x3[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x6[0],mm1);
		psubw_m2r(x1[0],mm1);	psubw_m2r(x7[0],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);

		movq_m2r( x0[0],mm1);	paddw_m2r(x8[0],mm1);	psraw_i2r(7,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4; x7+=4; x8+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_9_4_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,long n)
{
	long long	c[6] = { c4l(56<<8), c4l(110<<8), c4l(89<<8), c4l(22<<8), c4l(9<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);
	movq_m2r( c[5],mm7);

	do
	{
		movq_m2r( x1[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x0[0],mm1);	psraw_i2r(5,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x4[0],mm1);	pmulhw_r2r(mm5,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x5[0],mm1);	pmulhw_r2r(mm6,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x6[0],mm1);	psraw_i2r(6,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm7,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_9_4_ver_2(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,short *x7,long n)
{
	long long	c[4] = { c4l(102<<8), c4l(38<<8), c4l(6<<8), c4l(8) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x3[0],mm0);	paddw_m2r(x4[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x6[0],mm1);
		paddw_m2r(x0[0],mm1);	paddw_m2r(x7[0],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(4,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4; x7+=4;
		y+=4;
		n--;
	}
	while ( n );
}


void scale_9_4(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[9];
	register short	*tb0,*tb1,*tbh;
	register long	i,u,v;

	v=px&3;
	w+=v;
	px-=v;
	u=(w+3)>>2;
	v<<=2;

	tb0=((short *) tbi)+v;

	dx*=4;
	px*=9;
	py*=9;
	x+=4*((px>>2)+border)+((py>>2)+border-4)*dx;
	py&=3;

	for (i=0; i<7; i++)
	{
		buf[i]=tb0;
		scale_9_4_hor(tb0-v,x,u); x+=dx;
		tb0+=4*w;
	}
	buf[7]=tb0;	tb1=tb0+4*w;
	buf[8]=tb1;

	for (; h; h--)
	{
		scale_9_4_hor(tb0-v,x,u); x+=dx;
		scale_9_4_hor(tb1-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_9_4_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);	y+=dy; py=1;	break;
			case 1 : scale_9_4_ver_1(y,buf[1],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);			y+=dy; py=2;	break;
			case 2 : scale_9_4_ver_2(y,buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);		y+=dy; py=3;	break;
			case 3 : scale_9_4_ver_1(y,buf[8],buf[6],buf[5],buf[4],buf[3],buf[2],buf[1],w);			y+=dy; py=0;	break;
		}

		if ( py )
		{
			tb0=buf[0];
			tb1=buf[1];
			for (i=0; i<7; i++) buf[i]=buf[i+2];
			buf[7]=tb0;
			buf[8]=tb1;
		}
		else
		{
			tbh=buf[0];
			tb0=buf[1];
			tb1=buf[2];
			for (i=0; i<6; i++) buf[i]=buf[i+3];
			buf[6]=tbh;
			buf[7]=tb0;
			buf[8]=tb1;
			scale_9_4_hor(tbh-v,x,u); x+=dx;
		}
	}
	emms();
}


static void scale_5_2_hor(short *y,uchar *x,long n)
{
	long long	c[7] = { c4l(( 52)<<9), c4l(( 36)<<9), c4l((  9)<<9), c4l(( -3)<<9),
				 c4l(( 47)<<9), c4l(( 22)<<9), c4l(( -4)<<9)
				};
	long long	t0,t1;

	prefetch(x-12);

	pxor_r2r(mm7,mm7);

	ldu5(x[-16],mm0,mm7); movq_r2m(mm0,t0);
	ldu5(x[-12],mm1,mm7); movq_r2m(mm1,t1);
	ldu5(x[- 8],mm0,mm7);
	ldu5(x[- 4],mm1,mm7);
	ldu5(x[  0],mm2,mm7);
	ldu5(x[  4],mm3,mm7);
	ldu5(x[  8],mm4,mm7);

	for (; n; n--)
	{
		prefetch(x+20);

		ldu5(x[12],mm5,mm7);
		ldu5(x[16],mm6,mm7);

		pmulhw_m2r(c[0],mm2);
		movq_r2r(mm1,mm7); paddw_r2r(mm3,mm7); pmulhw_m2r(c[1],mm7); paddw_r2r(mm7,mm2);
		movq_r2r(mm0,mm7); paddw_r2r(mm4,mm7); pmulhw_m2r(c[2],mm7); paddw_r2r(mm7,mm2);
		movq_m2r(t1 ,mm7); paddw_r2r(mm5,mm7); psraw_i2r(6,mm7);     psubw_r2r(mm7,mm2);
		movq_m2r(t0 ,mm7); paddw_r2r(mm6,mm7); pmulhw_m2r(c[3],mm7); paddw_r2r(mm7,mm2);

		movq_r2m(mm2,y[0]);

		movq_r2m(mm3,t0);
		movq_r2m(mm4,t1);

		paddw_r2r(mm5,mm4); pmulhw_m2r(c[4],mm4);
		paddw_r2r(mm6,mm3); pmulhw_m2r(c[5],mm3); paddw_r2r(mm3,mm4);

		pxor_r2r(mm7,mm7);
		ldu5(x[24],mm3,mm7);

		paddw_r2r(mm3,mm1); pmulhw_m2r(c[6],mm1);     paddw_r2r(mm4,mm1);

		ldu5(x[28],mm4,mm7);

		paddw_r2r(mm4,mm0); psraw_i2r(8,mm0);         psubw_r2r(mm0,mm1);

		movq_r2m(mm1,y[4]);

		ldu5(x[20],mm2,mm7);

		movq_r2r(mm5,mm0);
		movq_r2r(mm6,mm1);

		x+=5*4;
		y+=2*4;
	}
}

static inline void scale_5_2_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,short *x7,short *x8,long n)
{
	long long	c[5] = { c4l(52<<9), c4l(36<<9), c4l(9<<9), c4l(3<<9), c4l(16) };

	do
	{
		movq_m2r( x4[0],mm0);
		pmulhw_m2r(c[0],mm0);

		movq_m2r( x3[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_m2r(c[1],mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x6[0],mm1);	pmulhw_m2r(c[2],mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x7[0],mm1);	psraw_i2r(5,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x8[0],mm1);	pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm0);

		paddw_m2r(c[4],mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4; x7+=4; x8+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_5_2_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,short *x7,long n)
{
	long long	c[3] = { c4l(47<<9), c4l(22<<9), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);


	do
	{
		movq_m2r( x3[0],mm0);	paddw_m2r(x4[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x6[0],mm1);	psraw_i2r(5,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x7[0],mm1);	psraw_i2r(7,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm4,mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4; x7+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_5_2(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[10];
	register short	*tb0,*tb1,*tbh;
	register long	i,u,v;

	v=px&1;
	w+=v;
	px-=v;
	u=(w+1)>>1;
	v<<=2;

	tb0=((short *) tbi)+v;

	dx*=4;
	px*=5;
	py*=5;
	x+=4*((px>>1)+border)+((py>>1)+border-4)*dx;
	py&=1;

	for (i=0; i<8; i++)
	{
		buf[i]=tb0;
		scale_5_2_hor(tb0-v,x,u); x+=dx;
		tb0+=4*w;
	}
	buf[8]=tb0;	tb1=tb0+4*w;
	buf[9]=tb1;

	for (; h; h--)
	{
		scale_5_2_hor(tb0-v,x,u); x+=dx;
		scale_5_2_hor(tb1-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_5_2_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);	y+=dy; py=1; 
				 tb0=buf[0];
				 tb1=buf[1];
				 for (i=0; i<8; i++) buf[i]=buf[i+2];
				 buf[8]=tb0;
				 buf[9]=tb1;
				 continue;

			case 1 : scale_5_2_ver_1(y,buf[0],buf[1],buf[3],buf[4],buf[5],buf[6],buf[8],buf[9],w);		y+=dy; py=0;
				 tbh=buf[0];
				 tb0=buf[1];
				 tb1=buf[2];
				 for (i=0; i<7; i++) buf[i]=buf[i+3];
				 buf[7]=tbh;
				 buf[8]=tb0;
				 buf[9]=tb1;
				 scale_5_2_hor(tbh-v,x,u); x+=dx;
				 continue;
		}
	}
	emms();
}


static void scale_8_3_hor(short *y,uchar *x,long n)
{
	long long	c[11] = { c4l(( 96)<<8), c4l(( 70)<<8), c4l(( 21)<<8), c4l(( -5)<<8), c4l(( -6)<<8),
				  c4l(( -7)<<8), c4l(( 37)<<8), c4l(( 83)<<8), c4l(( 92)<<8), c4l(( 54)<<8), c4l((  9)<<8)
				};
	long long	t0,t1;

	prefetch(x-16);

	pxor_r2r(mm7,mm7);

	ldu5(x[-16],mm0,mm7); movq_r2m(mm0,t0);
	ldu5(x[-12],mm1,mm7); movq_r2m(mm1,t1);
	ldu5(x[- 8],mm0,mm7);
	ldu5(x[- 4],mm1,mm7);
	ldu5(x[  0],mm2,mm7);
	ldu5(x[  4],mm3,mm7);

	for (; n; n--)
	{
		prefetch(x+16);

		ldu5(x[ 8],mm4,mm7);
		ldu5(x[12],mm5,mm7);
		ldu5(x[16],mm6,mm7);

		pmulhw_m2r(c[0],mm2);
		                   paddw_r2r(mm4,mm0); pmulhw_m2r(c[2],mm0); paddw_r2r(mm0,mm2);
		movq_r2r(mm1,mm0); paddw_r2r(mm3,mm0); pmulhw_m2r(c[1],mm0); paddw_r2r(mm0,mm2);
		movq_m2r(t1 ,mm0); paddw_r2r(mm5,mm0); pmulhw_m2r(c[3],mm0); paddw_r2r(mm0,mm2);
		movq_m2r(t0 ,mm0); paddw_r2r(mm6,mm0); pmulhw_m2r(c[4],mm0); paddw_r2r(mm0,mm2);
		movq_r2m(mm2,y[0]);


		pmulhw_m2r(c[5],mm1);
		movq_r2r(mm3,mm0); pmulhw_m2r(c[6],mm0); paddw_r2r(mm0,mm1);
		movq_r2r(mm4,mm0); pmulhw_m2r(c[7],mm0); paddw_r2r(mm0,mm1);
		movq_r2r(mm5,mm0); pmulhw_m2r(c[8],mm0); paddw_r2r(mm0,mm1);
		movq_r2r(mm6,mm0); pmulhw_m2r(c[9],mm0); paddw_r2r(mm0,mm1);

		movq_r2m(mm6,t0);

		pmulhw_m2r(c[10],mm5);
		psraw_i2r(1,mm3); paddw_r2r(mm3,mm4); psraw_i2r(5,mm4); psubw_r2r(mm4,mm5);
		pmulhw_m2r(c[9],mm6); paddw_r2r(mm6,mm5);

		ldu5(x[20],mm6,mm7);
		movq_r2r(mm6,mm0); pmulhw_m2r(c[10],mm6); paddw_r2r(mm1,mm6);

		movq_r2m(mm0,t1);

		pmulhw_m2r(c[8],mm0); paddw_r2r(mm0,mm5);

		ldu(x[24],mm0,mm7); psubw_r2r(mm0,mm6); psllw_i2r(5,mm0);
		ldu5(x[28],mm1,mm7);

		movq_r2r(mm1,mm2); psraw_i2r(6,mm2); psubw_r2r(mm2,mm6);
		movq_r2m(mm6,y[4]);

		movq_r2r(mm0,mm2); pmulhw_m2r(c[7],mm2); paddw_r2r(mm2,mm5);
		movq_r2r(mm1,mm2); pmulhw_m2r(c[6],mm2); paddw_r2r(mm2,mm5);

		ldu5(x[36],mm3,mm7);

		movq_r2r(mm3,mm2); pmulhw_m2r(c[5],mm2); paddw_r2r(mm2,mm5);
		movq_r2m(mm5,y[8]);

		ldu5(x[32],mm2,mm7);

		x+=8*4;
		y+=3*4;
	}
}

static inline void scale_8_3_ver_0(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,short *x7,short *x8,long n)
{
	long long	c[6] = { c4l(96<<8), c4l(70<<8), c4l(21<<8), c4l(5<<8), c4l(6<<8), c4l(16) };

	do
	{
		movq_m2r( x4[0],mm0);
		pmulhw_m2r(c[0],mm0);

		movq_m2r( x3[0],mm1);	paddw_m2r(x5[0],mm1);	pmulhw_m2r(c[1],mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x2[0],mm1);	paddw_m2r(x6[0],mm1);	pmulhw_m2r(c[2],mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x7[0],mm1);	pmulhw_m2r(c[3],mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x8[0],mm1);	pmulhw_m2r(c[4],mm1);	psubw_r2r(mm1,mm0);

		paddw_m2r(c[5],mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4; x7+=4; x8+=4;
		y+=4;
		n--;
	}
	while ( n );
}

static inline void scale_8_3_ver_1(uchar *y,short *x0,short *x1,short *x2,short *x3,short *x4,short *x5,short *x6,short *x7,long n)
{
	long long	c[7] = { c4l(9<<8), c4l(54<<8), c4l(92<<8), c4l(83<<8), c4l(37<<8), c4l(7<<8), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);
	movq_m2r( c[5],mm7);

	do
	{
		movq_m2r( x2[0],mm0);	pmulhw_r2r(mm2,mm0);
		movq_m2r( x3[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x4[0],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x5[0],mm1);	pmulhw_r2r(mm5,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x6[0],mm1);	pmulhw_r2r(mm6,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x7[0],mm1);	pmulhw_r2r(mm7,mm1);	psubw_r2r(mm1,mm0);

		movq_m2r( x0[0],mm1);	psraw_i2r(6,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	psraw_i2r(5,mm1);	psubw_r2r(mm1,mm0);

		paddw_m2r(c[6],mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=4; x1+=4; x2+=4; x3+=4; x4+=4; x5+=4; x6+=4; x7+=4;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_8_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	short		*buf[9];
	register short	*tb0,*tb1,*tbh;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;
	v<<=2;

	tb0=((short *) tbi)+v;

	dx*=4;
	px*=8;
	py*=8;
	x+=4*((px/3)+border)+((py/3)+border-4)*dx;
	py%=3;

	for (i=0; i<7; i++)
	{
		buf[i]=tb0;
		scale_8_3_hor(tb0-v,x,u); x+=dx;
		tb0+=4*w;
	}
	tb1=tb0+4*w;

	for (; h; h--)
	{
		buf[7]=tb0;
		buf[8]=tb1;

		scale_8_3_hor(tb0-v,x,u); x+=dx;
		scale_8_3_hor(tb1-v,x,u); x+=dx;

		switch ( py ) {
			case 0 : scale_8_3_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);	y+=dy; py=2;
				 tb0=buf[0];
				 tb1=buf[1];
				 for (i=0; i<7; i++) buf[i]=buf[i+2];
				 continue;

			case 1 : scale_8_3_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[8],w);		y+=dy; py=0;

			case 2 : tbh=buf[0];
				 tb0=buf[1];
				 tb1=buf[2];
				 for (i=0; i<6; i++) buf[i]=buf[i+3];
				 buf[6]=tbh;
				 scale_8_3_hor(tbh-v,x,u); x+=dx;
				 if ( !py ) continue;

				 scale_8_3_ver_1(y,tbh,buf[5],buf[4],buf[3],buf[2],buf[1],buf[0],tb0,w);		y+=dy; py=1;
				 continue;
		}
	}
	emms();
}

static void scale_3_1_hor(short *y,uchar *x,long n)
{
	long long	c[4] = { c4l(( 86)<<8), c4l(( 68)<<8), c4l(( 31)<<8), c4l((-10)<<8) };
	long long	t0,t1,zm;


	prefetch(x-12);

	pxor_r2r(mm7,mm7); movq_r2m(mm7,zm);

	ldu5(x[-20],mm0,mm7); movq_r2m(mm0,t0);
	ldu5(x[-16],mm1,mm7); movq_r2m(mm0,t1);
	ldu5(x[- 8],mm0,mm7);
	ldu5(x[- 4],mm1,mm7);
	ldu5(x[  0],mm2,mm7);
	ldu5(x[  4],mm3,mm7);
	ldu5(x[  8],mm4,mm7);

	for (; n; n--)
	{
		prefetch(x+20);

		pxor_r2r(mm7,mm7);
		ldu5(x[16],mm5,mm7);
		ldu5(x[20],mm6,mm7);
		pmulhw_m2r(c[0],mm2);
		movq_r2r(mm1,mm7); paddw_r2r(mm3,mm7); pmulhw_m2r(c[1],mm7); paddw_r2r(mm7,mm2);
		movq_r2r(mm0,mm7); paddw_r2r(mm4,mm7); pmulhw_m2r(c[2],mm7); paddw_r2r(mm7,mm2);
		movq_m2r(t1 ,mm7); paddw_r2r(mm5,mm7); pmulhw_m2r(c[3],mm7); paddw_r2r(mm7,mm2);
		movq_m2r(t0 ,mm7); paddw_r2r(mm6,mm7); psraw_i2r(6,mm7); psubw_r2r(mm7,mm2);
		movq_r2m(mm2,y[0]);

		movq_r2m(mm4,t1);
		movq_r2m(mm3,t0);

		paddw_r2r(mm5,mm4); pmulhw_m2r(c[1],mm4);
		paddw_r2r(mm6,mm3); pmulhw_m2r(c[2],mm3); paddw_r2r(mm3,mm4);

		ldu5m(x[24],mm2,zm);
		ldu5m(x[28],mm3,zm);

		paddw_r2r(mm3,mm1); pmulhw_m2r(c[3],mm1); paddw_r2r(mm4,mm1);

		ldu5m(x[32],mm4,zm);

		paddw_r2r(mm4,mm0); psraw_i2r(6,mm0); psubw_r2r(mm0,mm1);

		ldu5m(x[12],mm0,zm); pmulhw_m2r(c[0],mm0); paddw_r2r(mm0,mm1);
		movq_r2m(mm1,y[12]);

		movq_r2r(mm5,mm0);
		movq_r2r(mm6,mm1);

/*
		y[0]=(86*x[0]+68*(x[-4]+x[4])+31*(x[-8]+x[ 8])-10*(x[-16]+x[16])-4*(x[-20]+x[20]))>>3;
		y[1]=(86*x[1]+68*(x[-3]+x[5])+31*(x[-7]+x[ 9])-10*(x[-15]+x[17])-4*(x[-19]+x[21]))>>3;
		y[2]=(86*x[2]+68*(x[-2]+x[6])+31*(x[-6]+x[10])-10*(x[-14]+x[18])-4*(x[-18]+x[22]))>>3;
		y[3]=0;
*/

		x+=24;
		y+=4*3*2;
	}
}

static inline void scale_3_1_ver(uchar *y,uchar *x0,uchar *x1,uchar *x2,uchar *x3,long n)
{
	long long	c[5] = { c4l(86<<8), c4l(68<<8), c4l(31<<8), c4l(10<<8), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);

	do
	{
		movq_m2r( x1[16],mm0);
		pmulhw_r2r(mm2,mm0);

		movq_m2r( x1[8],mm1);	paddw_m2r(x2[0],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x2[8],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x0[8],mm1);	paddw_m2r(x3[0],mm1);	pmulhw_r2r(mm5,mm1);	psubw_r2r(mm1,mm0);
		movq_m2r( x0[0],mm1);	paddw_m2r(x3[8],mm1);	psraw_i2r(6,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm6,mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=24; x1+=24; x2+=24; x3+=24;
		y+=4;
		n--;
	}
	while ( n );
}


void scale_3_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register uchar	*tb0, *tb1,*tb2,*tb3, *ttb;
	register long	i,u;

	dx*=4;
	x+=4*(3*px+border)+(3*py+border-5)*dx;

	u=(w+1)>>1;

	tb0=(uchar *) tbi;	for (i=0; i<24; i+=8) { scale_3_1_hor((short *) (tb0+i),x,u); x+=dx; }
	tb1=tb0+24*2*u;		for (i=0; i<24; i+=8) { scale_3_1_hor((short *) (tb1+i),x,u); x+=dx; }
	tb2=tb1+24*2*u;		for (i=0; i<24; i+=8) { scale_3_1_hor((short *) (tb2+i),x,u); x+=dx; }
	tb3=tb2+24*2*u;

	do
	{
		for (i=0; i<24; i+=8) { scale_3_1_hor((short *) (tb3+i),x,u); x+=dx; }

		scale_3_1_ver(y,tb0,tb1,tb2,tb3,w); y+=dy;

		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;

		h--;
	}
	while ( h );

	emms();
}

static void scale_4_1_hor(short *y,uchar *x,long n)
{
	long long	c[3] = { c4l(28), c4l(19), c4l(-3) };

	prefetch(x-36);
	prefetch(x- 4);

	pxor_r2r(mm7,mm7);

	do
	{
		prefetch(x+28);

		movd_m2r(x[0],mm0); punpcklbw_r2r(mm7,mm0); psllw_i2r(2,mm0);

		ldmul2(x[-4],x[4],mm1,c[0],mm7,mm6);
		ldmac2(x[-8],x[8],mm1,c[1],mm7,mm5,mm6);

		movd_m2r(x[-12],mm2);	movd_m2r(x[12],mm3); 
		punpcklbw_r2r(mm7,mm2);	punpcklbw_r2r(mm7,mm3); 
		paddw_r2r(mm3,mm2);	paddw_r2r(mm2,mm0);

		movd_m2r(x[-24],mm2);	movd_m2r(x[-20],mm3); 
		punpcklbw_r2r(mm7,mm2);	punpcklbw_r2r(mm7,mm3);
		movd_m2r(x[20],mm4);	movd_m2r(x[24],mm5); 
		punpcklbw_r2r(mm7,mm4);	punpcklbw_r2r(mm7,mm5);
		paddw_r2r(mm3,mm2);	paddw_r2r(mm5,mm4);
		paddw_r2r(mm4,mm2);
		pmullw_m2r(c[2],mm2);	paddw_r2r(mm2,mm1);

		movd_m2r(x[-28],mm2);	movd_m2r(x[28],mm3); 
		punpcklbw_r2r(mm7,mm2);	punpcklbw_r2r(mm7,mm3);
		paddw_r2r(mm3,mm2);	psubw_r2r(mm2,mm1);

		psraw_i2r(3,mm1);
		paddw_r2r(mm1,mm0);
		movq_r2m(mm0,*y);


/*
		y[0]=(32*x[0]+28*(x[-4]+x[4])+19*(x[-8]+x[8])+8*(x[-12]+x[12])-3*(x[-20]+x[20]+x[-24]+x[24])-(x[-28]+x[28]))>>3;
		y[1]=(32*x[1]+28*(x[-3]+x[5])+19*(x[-7]+x[9])+8*(x[-11]+x[13])-3*(x[-19]+x[21]+x[-23]+x[25])-(x[-27]+x[29]))>>3;
		y[2]=(32*x[2]+28*(x[-2]+x[6])+19*(x[-6]+x[10])+8*(x[-10]+x[14])-3*(x[-18]+x[22]+x[-22]+x[26])-(x[-26]+x[30]))>>3;
		y[3]=0;
*/
		x+=16;
		y+=16;
		n--;
	}
	while ( n );
}

static inline void scale_4_1_ver(uchar *y,uchar *x0,uchar *x1,uchar *x2,uchar *x3,long n)
{
	long long	c[4] = { c4l(28<<10), c4l(19<<10), c4l(3<<10), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);

	do
	{
		movq_m2r( x1[24],mm0);
		psraw_i2r(1,mm0);

		movq_m2r( x1[16],mm1);	paddw_m2r(x2[0],mm1);	pmulhw_r2r(mm2,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[8],mm1);	paddw_m2r(x2[8],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[0],mm1);	paddw_m2r(x2[16],mm1);	psraw_i2r(3,mm1);	paddw_r2r(mm1,mm0);

		movq_m2r( x0[8],mm1);	paddw_m2r(x0[16],mm1);
		paddw_m2r(x3[0],mm1);	paddw_m2r(x3[8],mm1);	pmulhw_r2r(mm4,mm1);	psubw_r2r(mm1,mm0);

		movq_m2r( x0[0],mm1);	paddw_m2r(x3[16],mm1);	psraw_i2r(6,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm5,mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=32; x1+=32; x2+=32; x3+=32;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_4_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register uchar	*tb0,*tb1,*tb2,*tb3,*ttb;
	register long	i;

	dx*=4;
	x+=4*(4*px+border)+(4*py+border-7)*dx;

	tb0=(uchar *) tbi;	for (i=0; i<32; i+=8) { scale_4_1_hor((short *) (tb0+i),x,w); x+=dx; }
	tb1=tb0+32*w;		for (i=0; i<32; i+=8) { scale_4_1_hor((short *) (tb1+i),x,w); x+=dx; }
	tb2=tb1+32*w;		for (i=0; i<32; i+=8) { scale_4_1_hor((short *) (tb2+i),x,w); x+=dx; }
	tb3=tb2+32*w;

	do
	{
		for (i=0; i<32; i+=8) { scale_4_1_hor((short *) (tb3+i),x,w); x+=dx; }

		scale_4_1_ver(y,tb0,tb1,tb2,tb3,w); y+=dy;

		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;

		h--;
	}
	while ( h );

	emms();
}

static void scale_5_1_hor(short *y,uchar *x,long n)
{
	long long	c[6] = { c4l(25), c4l(23), c4l(35), c4l(21), c4l(-3), c4l(16) };

	pxor_r2r(mm7,mm7);

	prefetch(x-32);
	prefetch(x);

	do
	{
		prefetch(x+32);

		ldmul(x[0],mm0,c[0],mm7);
		ldmac2(x[-4],x[4],mm0,c[1],mm7,mm5,mm6);

		ldmul2(x[-8],x[8],mm1,c[2],mm7,mm6);
		ldmac2(x[-12],x[12],mm1,c[3],mm7,mm5,mm6);

		movd_m2r(x[-16],mm2);	movd_m2r(x[-16],mm3); 
		punpcklbw_r2r(mm7,mm2);	punpcklbw_r2r(mm7,mm3);
		paddw_r2r(mm3,mm2);	psllw_i2r(2,mm2);	paddw_r2r(mm2,mm0);

		movd_m2r(x[-28],mm2);	movd_m2r(x[-24],mm3); 
		punpcklbw_r2r(mm7,mm2);	punpcklbw_r2r(mm7,mm3);
		movd_m2r(x[24],mm4);	movd_m2r(x[28],mm5); 
		punpcklbw_r2r(mm7,mm4);	punpcklbw_r2r(mm7,mm5);
		paddw_r2r(mm3,mm2);	paddw_r2r(mm5,mm4);
		paddw_r2r(mm4,mm2);
		pmullw_m2r(c[4],mm2);	paddw_r2r(mm2,mm1);

		movd_m2r(x[-32],mm2);	movd_m2r(x[32],mm3); 
		punpcklbw_r2r(mm7,mm2);	punpcklbw_r2r(mm7,mm3);
		paddw_r2r(mm3,mm2);	psubw_r2r(mm2,mm1);

		psraw_i2r(3,mm0);
		psraw_i2r(4,mm1);
		paddw_r2r(mm1,mm0);
		movq_r2m(mm0,*y);

/*
		y[0]=(50*x[0]+46*(x[-4]+x[4])+35*(x[-8]+x[8])+21*(x[-12]+x[12])+8*(x[-16]+x[16])-3*(x[-24]+x[24]+x[-28]+x[28])-(x[-32]+x[32]))>>4;
		y[1]=(50*x[1]+46*(x[-3]+x[5])+35*(x[-7]+x[9])+21*(x[-11]+x[13])+8*(x[-15]+x[17])-3*(x[-23]+x[25]+x[-27]+x[29])-(x[-31]+x[33]))>>4;
		y[2]=(50*x[2]+46*(x[-2]+x[6])+35*(x[-6]+x[10])+21*(x[-10]+x[14])+8*(x[-14]+x[18])-3*(x[-22]+x[26]+x[-26]+x[30])-(x[-30]+x[34]))>>4;
		y[3]=0;
*/
		x+=20;
		y+=20;
		n--;
	}
	while ( n );
}

static inline void scale_5_1_ver(uchar *y,uchar *x0,uchar *x1,uchar *x2,uchar *x3,long n)
{
	long long	c[6] = { c4l(50<<9), c4l(46<<9), c4l(35<<9), c4l(21<<9), c4l(3<<9), c4l(16) };

	movq_m2r( c[0],mm2);
	movq_m2r( c[1],mm3);
	movq_m2r( c[2],mm4);
	movq_m2r( c[3],mm5);
	movq_m2r( c[4],mm6);
	movq_m2r( c[5],mm7);

	do
	{
		movq_m2r( x1[24],mm0);
		pmulhw_r2r(mm2,mm0);

		movq_m2r( x1[16],mm1);	paddw_m2r(x1[32],mm1);	pmulhw_r2r(mm3,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[ 8],mm1);	paddw_m2r(x2[ 0],mm1);	pmulhw_r2r(mm4,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x1[ 0],mm1);	paddw_m2r(x2[ 8],mm1);	pmulhw_r2r(mm5,mm1);	paddw_r2r(mm1,mm0);
		movq_m2r( x0[32],mm1);	paddw_m2r(x2[16],mm1);	psraw_i2r(4,mm1);	paddw_r2r(mm1,mm0);

		movq_m2r( x0[ 8],mm1);	paddw_m2r(x0[16],mm1);
		paddw_m2r(x2[32],mm1);	paddw_m2r(x3[ 0],mm1);	pmulhw_r2r(mm6,mm1);	psubw_r2r(mm1,mm0);

		movq_m2r( x0[ 0],mm1);	paddw_m2r(x3[ 8],mm1);	psraw_i2r(7,mm1);	psubw_r2r(mm1,mm0);

		paddw_r2r(mm7,mm0);
		psraw_i2r(5,mm0);

		packuswb_r2r(mm0,mm0);
		movd_r2m(mm0,y[0]);

		x0+=40; x1+=40; x2+=40; x3+=40;
		y+=4;
		n--;
	}
	while ( n );
}

void scale_5_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register uchar	*tb0,*tb1,*tb2,*tb3,*ttb;
	register long	i;

	dx*=4;
	x+=4*(5*px+border)+(5*py+border-7)*dx;

	tb0=(uchar *) tbi;	for (i=0; i<5; i++) { scale_5_1_hor((short *) (tb0+8*i),x,w); x+=dx; }
	tb1=tb0+40*w;		for (i=0; i<5; i++) { scale_5_1_hor((short *) (tb1+8*i),x,w); x+=dx; }
	tb2=tb1+40*w;		for (i=0; i<5; i++) { scale_5_1_hor((short *) (tb2+8*i),x,w); x+=dx; }
	tb3=tb2+40*w;

	do
	{
		for (i=0; i<5; i++) { scale_5_1_hor((short *) (tb3+8*i),x,w); x+=dx; }

		scale_5_1_ver(y, tb0, tb1, tb2,	tb3, w); y+=dy;

		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;
		h--;
	}
	while ( h );

	emms();
}

#ifdef test

#define rdtsc(low,high) __asm__ __volatile__("rdtsc" : "=a" (low), "=d" (high))
#define rdtscl(low)     __asm__ __volatile__("rdtsc" : "=a" (low) : : "edx")

#define n	400

int main()
{
	long	a,b,c,i;
	int	x[32+1200];
	long long y[n+4];

	for (i=0; i<10; i++)
	{
		rdtscl(a);
		rdtscl(b);
		scale_3_1_hor((short *)  y   ,(uchar *) (x+16),n/6);
		scale_3_1_hor((short *) (y+1),(uchar *) (x+16),n/6);
		scale_3_1_hor((short *) (y+2),(uchar *) (x+16),n/6);
		rdtscl(c);
	}
	emms();
	printf("%f %f\n",((double) (b-a))/((double) n),((double) (c-b))/((double) n));
	return 0;
}
#endif

