
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sc.h"

#define uint		unsigned int
#define int64		long long
#define uint64		unsigned long long

#define rep4l(x)	(x|(x<<16)|(x<<32)|(x<<48))
#define rep4(x)		rep4l((((uint64) (x))&0xFFFF))


#define asmv	__asm__ __volatile__

#define lfetch_pre(p)	\
		p+=64;						\
		asmv("lfetch [%0],64" : "=r"(p) : "r"(p) );	\
		asmv("lfetch [%0],64" : "=r"(p) : "r"(p) );	\
		asmv("lfetch [%0],64" : "=r"(p) : "r"(p) )


static void scale_1_4_hor(int64 *y,uchar *x,long n)
{
	register int64	x1,x2,x3,x4;
	register uint64	t0,t1,t2,t3,t4,t5,t6;
	register uint64	c0,c1,c2;
	register int64	*z;
	register uchar	*q;

	q=x-4;

	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);

	z=y+1;

	c0=rep4(( 56)<<5);
	c1=rep4(( 37)<<5);
	c2=rep4(( -5)<<5);

	while ( n-- )
	{
		asmv("ld4		%0=[%1],4"	: "=r"(x4),"=r"(x)	: "r"(x)		);
		asmv("pshl2		%0=%1,4"	: "=r"(t0)		: "r"(x2)		);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t1)		: "r"(x1), "r"(x1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x3), "r"(c0)	);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(x2), "r"(c0)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t1)		: "r"(x4), "r"(t1)	);
		asmv("pshladd2		%0=%1,2,%2"	: "=r"(t6)		: "r"(x2), "r"(t6)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x2), "r"(x3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x1), "r"(x4)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t5)		: "r"(x4), "r"(x4)	);
		asmv("pshladd2		%0=%1,2,%2"	: "=r"(t2)		: "r"(x3), "r"(t2)	);


		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c2)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t5)		: "r"(x1), "r"(t5)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t2), "r"(t1)	);


		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t1), "r"(z)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t6), "r"(t5)	);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x2)		);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t3), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t5), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x3)		);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x4)		);
	}
}

static inline void scale_1_4_ver_0(uchar *y,int64 *x,long n)
{
	register uint64	s0;
	register uint64	t0;
	register uint64	c0;
	register uchar	*z;
	register int64	*q;

	z=y+4;
	q=x+1;

	c0=rep4(8);

	while ( n-- )
	{
		asmv("ld8		%0=[%1],16"	: "=r"(s0),"=r"(x)	: "r"(x)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t0),"=r"(q)	: "r"(q)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("pshr2		%0=%1,4"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,4"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_1_4_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s1,s2,s3;
	register uint64	t0,t1,t2,t3;
	register uint64	c0,c1,c2;
	register uchar	*z;

	z=y+4;

	c0=rep4((  3)<<4);
	c1=rep4(( 28)<<4);
	c2=rep4( 32 );


	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(c2)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s0)		: "r"(s3), "r"(s0)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t3), "r"(t0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s1), "r"(s0)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_1_4_ver_2(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s1,s2,s3;
	register uint64	t0,t1,t2,t3;
	register uint64	c0,c1,c2;
	register uchar	*z;

	z=y+4;

	c0=rep4(( 37)<<3);
	c1=rep4(( -5)<<3);
	c2=rep4( 32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x2)	: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c1)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c1)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_1_4(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[4];
	register int64	*tb;
	register long	i,j,u,v;

	v=px&3;
	w+=v;
	px-=v;
	u=(w+3)>>2;

	dx*=4;
	x+=4*((px>>2)+border)+((py>>2)+border-1)*dx;
	py&=3;

	tb=((int64 *) tbi)+v;

	for (i=0; i<4; i++)
	{
		buf[i]=tb;
		scale_1_4_hor(tb-v,x,u); x+=dx;
		tb+=4*u;
	}

	w=(w+1)>>1;

	for (j=py; j<py+h; j++)
	{
		switch ( j&3 ) {
			case 0 : scale_1_4_ver_0(y,       buf[1],              w); y+=dy;	continue;
			case 1 : scale_1_4_ver_1(y,buf[0],buf[1],buf[2],buf[3],w); y+=dy;	continue;
			case 2 : scale_1_4_ver_2(y,buf[0],buf[1],buf[2],buf[3],w); y+=dy;	continue;
			case 3 : scale_1_4_ver_1(y,buf[3],buf[2],buf[1],buf[0],w); y+=dy;
				 tb=buf[0]; for (i=0; i<3; i++) buf[i]=buf[i+1]; buf[3]=tb;
				 scale_1_4_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
}

static void scale_1_3_hor(int64 *y,uchar *x,long n)
{
	register int64	x0,x1,x2,x3,x4,x5;
	register uint64	ta,t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11;
	register uint64	c0,c1,c2,c3,c4,c5;
	register int64	*z;
	register uchar	*q,*p;

	p=x-8;
	q=x-8;
	x-=4;

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);

	z=y+1;

	c0=rep4((  5)<<4);
	c1=rep4((-20)<<4);
	c2=rep4((104)<<4);
	c3=rep4(( 49)<<4);
	c4=rep4((-13)<<4);
	c5=rep4((  3)<<4);

	while ( n-- )
	{
		asmv("ld4		%0=[%1],4"	: "=r"(x5),"=r"(x)	: "r"(x)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(x1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(x2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(x3), "r"(c3)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x0), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x1), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x2), "r"(c3)	);


		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(x4), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x5), "r"(c5)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x1)		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t9)		: "r"(x3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t10)		: "r"(x4), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t11)		: "r"(x5), "r"(c0)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(t8), "r"(t9)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t10)		: "r"(t10), "r"(t11)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t8)	);
		asmv("pshl2		%0=%1,4"	: "=r"(ta)		: "r"(x2)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x2)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t10)	);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x3)		);


		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(ta), "r"(y)	);
		asmv("st8		[%0]=%1,24"	: "=r"(z)		: "r"(t0), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x4)		);


		asmv("st8		[%0]=%1,8"	: "=r"(y)		: "r"(t6), "r"(y)	);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x5)		);
	}
}

static inline void scale_1_3_ver_0(uchar *y,int64 *x,long n)
{
	register uint64	s0;
	register uint64	t0;
	register uint64	c0;
	register uchar	*z;
	register int64	*q;

	z=y+4;
	q=x+1;

	c0=rep4(8);

	while ( n-- )
	{
		asmv("ld8		%0=[%1],16"	: "=r"(s0),"=r"(x)	: "r"(x)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t0),"=r"(q)	: "r"(q)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("pshr2		%0=%1,4"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,4"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


static inline void scale_1_3_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5;
	register uint64	t0,t1,t2,t3,t4,t5;
	register uint64	c0,c1,c2,c3,c4,c5,c6;
	register uchar	*z;

	z=y+4;

	c0=rep4((  5)<<2);
	c1=rep4((-20)<<2);
	c2=rep4((104)<<2);
	c3=rep4(( 49)<<2);
	c4=rep4((-13)<<2);
	c5=rep4((  3)<<2);
	c6=rep4(  32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x5)	: "r"(x5)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x5)	: "r"(x5)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(c6)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(c6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s4)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_1_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[6];
	register int64	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;

	dx*=4;
	x+=4*((px/3)+border)+((py/3)+border-2)*dx;
	py%=3;

	tb=((int64 *) tbi)+v;

	w=(w+1)>>1;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_1_3_hor(tb-v,x,u); x+=dx;
		tb+=3*u;
	}

	for (; h; h--)
	{
		switch ( py ) {
			case 0 : scale_1_3_ver_0(y,              buf[2],                     w); y+=dy; py=1;	continue;
			case 1 : scale_1_3_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],w); y+=dy; py=2;	continue;
			case 2 : scale_1_3_ver_1(y,buf[5],buf[4],buf[3],buf[2],buf[1],buf[0],w); y+=dy; py=0;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_1_3_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
}

static void scale_1_2_hor(int64 *y,uchar *x,long n)
{
	register int64	x0,x1,x2,x3,x4,x5,x6;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7;
	register uint64	c0,c1;
	register int64	*z;
	register uchar	*q,*p;

	p=x-8;
	q=x-8;
	x-=4;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);

	z=y+1;

	c0=rep4((39)<<5);
	c1=rep4((-9)<<5);


	while ( n-- )
	{
		asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(q)	: "r"(q)		);
		asmv("pshl2		%0=%1,4"	: "=r"(t0)		: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x2), "r"(x3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x1), "r"(x4)	);
		asmv("pshl2		%0=%1,4"	: "=r"(t4)		: "r"(x3)		);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(x3), "r"(x4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c0)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x0), "r"(x5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(x2), "r"(x5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(x1), "r"(x6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c0)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x2)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x3)		);

		asmv("lfetch [%0],16" : "=r"(p) : "r"(p) );

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t1)		: "r"(t3), "r"(t1)	);

		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t5)		: "r"(t7), "r"(t5)	);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x4)		);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x5)		);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t1), "r"(z)	);


		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t4), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t5), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x6)		);
	}
}


static inline void scale_1_2_ver_0(uchar *y,int64 *x,long n)
{
	register uint64	s0;
	register uint64	t0;
	register uint64	c0;
	register uchar	*z;
	register int64	*q;

	z=y+4;
	q=x+1;

	c0=rep4(8);

	while ( n-- )
	{
		asmv("ld8		%0=[%1],16"	: "=r"(s0),"=r"(x)	: "r"(x)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t0),"=r"(q)	: "r"(q)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("pshr2		%0=%1,4"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,4"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


static inline void scale_1_2_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5;
	register uint64	t0,t1,t2,t3,t4,t5;
	register uint64	c0,c1,c2;
	register uchar	*z;

	z=y+4;

	c0=rep4( ( 39)<<3);
	c1=rep4( ( -9)<<3);
	c2=rep4( 32);

// a=39*(x2[0]+x3[0])-9*(x1[0]+x4[0])+2*(x0[0]+x5[0]);

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x3)	: "r"(x3)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x4)	: "r"(x4)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x4)	: "r"(x4)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x5)	: "r"(x5)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x5)	: "r"(x5)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s4)		: "r"(s4), "r"(c2)	);

		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t4)		: "r"(t4), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s4)	);

		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


void scale_1_2(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[6];
	register int64	*tb;
	register long	i,u,v;

	v=px&1;
	w+=v;
	px-=v;
	u=(w+3)/4;

	dx*=4;
	x+=4*((px>>1)+border)+((py>>1)+border-2)*dx;
	py&=1;

	tb=((int64 *) tbi)+v;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_1_2_hor(tb-v,x,u); x+=dx;
		tb+=4*u;
	}

	w=(w+1)>>1;

	for (; h; h--)
	{
		switch ( py ) {
			case 0 : scale_1_2_ver_0(y,              buf[2],                     w); y+=dy; py=1;	continue;
			case 1 : scale_1_2_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],w); y+=dy; py=0;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_1_2_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
}

static void scale_2_3_hor(int64 *y,uchar *x,long n)
{
	register int64	x0,x1,x2,x3,x4,x5,x6;
	register uint64	ta,t0,t1,t2,t3,t4,t5,t6,t7,t8,t10,t11;
	register uint64	c0,c1,c2,c3,c4,c5;
	register int64	*z;
	register uchar	*q,*p;

	q=x-8;
	p=x-8;
	x-=4;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);

	z=y+1;

	c0=rep4((  5)<<4);
	c1=rep4((-20)<<4);
	c2=rep4((104)<<4);
	c3=rep4(( 49)<<4);
	c4=rep4((-13)<<4);
	c5=rep4((  3)<<4);

	while ( n-- )
	{
		asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(q)	: "r"(q)		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x1), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(x2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x0), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x1), "r"(c4)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(x3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(x4), "r"(c3)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x2), "r"(c3)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(x5), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x6), "r"(c5)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t10)		: "r"(x4), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t11)		: "r"(x5), "r"(c0)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(t8), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t10)		: "r"(t10), "r"(t11)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t8)	);
		asmv("pshl2		%0=%1,4"	: "=r"(ta)		: "r"(x2)		);

		asmv("lfetch [%0],16" : "=r"(p) : "r"(p) );

		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x2)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t10)	);

		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x3)		);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x4)		);


		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(ta), "r"(y)	);
		asmv("st8		[%0]=%1,24"	: "=r"(z)		: "r"(t6), "r"(z)	);

		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x5)		);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x6)		);

		asmv("st8		[%0]=%1,8"	: "=r"(y)		: "r"(t0), "r"(y)	);
	}
}


void scale_2_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[6];
	register int64	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;

	dx*=4;
	px*=2;
	py*=2;
	x+=4*(px/3+border)+(py/3+border-2)*dx;
	py%=3;

	tb=(int64 *) tbi;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_2_3_hor(tb-v,x,u); x+=dx;
		tb+=3*u;
	}

	for (; h; h--)
	{
		switch ( py ) {
			case 0 : scale_1_3_ver_0(y,              buf[2],                     w); y+=dy; py=2;
				 continue;
			case 1 : scale_1_3_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],w); y+=dy; py=0;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_2_3_hor(tb-v,x,u); x+=dx;
				 continue;
			case 2 : scale_1_3_ver_1(y,buf[5],buf[4],buf[3],buf[2],buf[1],buf[0],w); y+=dy; py=1;
				 tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
				 scale_2_3_hor(tb-v,x,u); x+=dx;
				 continue;
		}
	}
}

void scale_1_1(int *tb,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	dx*=4;
	x+=4*(px+border)+(py+border)*dx;

	do
	{
		memcpy(y,x,4*w);
		x+=dx;
		y+=dy;
		h--;
	}
	while ( h );	
}


static void scale_6_5_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6,x7,x9;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14;
	register uint64	c0,c1,c2,c3,c4,c5,c6;
	register int64	*z;
	register uchar	*q,*p;

	q=x-4;
	p=x-8;
	x-=8;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);

	c0=rep4((106)<<4);
	c1=rep4(( -5)<<4);

	c2=rep4((101)<<4);
	c3=rep4(( 38)<<4);
	c4=rep4((  9)<<4);

	c5=rep4(( 84)<<4);
	c6=rep4(( 62)<<4);

	z=y+1;

/*
0	 y[0]=106*x[0]+16*(x[-4]+x[4])-5*(x[-8]+x[8]);
1	 y[0]=-2*x[-8]+101*x[0]+38*x[4]-9*x[8];
2	 y[0]=-8*x[-4]+84*x[0]+62*x[4]-10*x[8];
3	 y[0]=-10*x[-4]+62*x[0]+84*x[4]-8*x[8];
4	 y[0]=-9*x[-4]+38*x[0]+101*x[4]-2*x[12];
*/

	while ( n-- )
	{
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x2), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x1), "r"(x3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(x3), "r"(c2)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);

		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);

		asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x0), "r"(x4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(x4), "r"(c3)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x5), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(x3), "r"(x6)	);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x9) 		);


		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x4), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x5), "r"(c6)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(x7), "r"(x4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t10)		: "r"(x6), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t11)		: "r"(x5), "r"(c6)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t12)		: "r"(x7), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t13)		: "r"(x6), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t14)		: "r"(x5), "r"(c4)	);

		asmv("lfetch [%0],24" : "=r"(p) : "r"(p) );

		asmv("pshladd2		%0=%1,1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);

		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t5)		: "r"(x1), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);

		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t6)		: "r"(x6), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t8)	);

		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t9)		: "r"(x4), "r"(t9)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t10)		: "r"(t10), "r"(t11)	);

		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t14)		: "r"(x3), "r"(t14)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t12)		: "r"(t12), "r"(t13)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t5)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t7), "r"(t6)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t10), "r"(t9)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t12)		: "r"(t12), "r"(t14)	);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t3), "r"(z)	);
		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t6), "r"(y)	);
		asmv("st8		[%0]=%1,24"	: "=r"(z)		: "r"(t9), "r"(z)	);
		asmv("st8		[%0]=%1,8"	: "=r"(y)		: "r"(t12), "r"(y)	);

		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x6)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x7)		);
	}
}

static inline void scale_6_5_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,long n)
{
	register uint64	s0,s1,s2,s3,s4;
	register uint64	t0,t1,t2,t3,t4;
	register uint64	c0,c1,c2;
	register uchar	*z;

	z=y+4;

	c0=rep4((106)<<2);
	c1=rep4(( -5)<<2);
	c2=rep4(  32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x0)	: "r"(x0)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(s0)		: "r"(s1), "r"(s0)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


static inline void scale_6_5_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s1,s2,s3;
	register uint64	t0,t1,t2,t3;
	register uint64	c0,c1,c2,c3;
	register uchar	*z;

	z=y+4;

	c0=rep4((101)<<2);
	c1=rep4(( 38)<<2);
	c2=rep4((  9)<<2);
	c3=rep4( -64 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s0)		: "r"(s0), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t0), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s1), "r"(s0)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_6_5_ver_2(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s1,s2,s3;
	register uint64	t0,t1,t2,t3;
	register uint64	c0,c1,c2,c3;
	register uchar	*z;

	z=y+4;

	c0=rep4(( 84)<<2);
	c1=rep4(( 62)<<2);
	c2=rep4(( 10)<<2);
	c3=rep4( -32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(s0)		: "r"(s0), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t0)		: "r"(t0), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s1), "r"(s0)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


void scale_6_5(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[6];
	register int64	*tb;
	register long	i,u,v;

	v=px%5;
	w+=v;
	px-=v;
	u=(w+4)/5;

	dx*=4;
	px*=6;
	py*=6;
	x+=4*((px/5)+border)+((py/5)+border-2)*dx;
	py%=5;

	tb=((int64 *) tbi)+v;

	for (i=0; i<5; i++)
	{
		buf[i]=tb;
		scale_6_5_hor(tb-v,x,u); x+=dx;
		tb+=5*u;
	}
	buf[5]=tb;

	w=(w+1)>>1;

	for (; h; h--)
	{
		scale_6_5_hor(tb-v,x,u); x+=dx;

		switch ( py ) {
			case 0 : scale_6_5_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],w);	y+=dy; py=1;  break;
			case 1 : scale_6_5_ver_1(y,buf[0],buf[2],buf[3],buf[4],w);		y+=dy; py=2;  break;
			case 2 : scale_6_5_ver_2(y,buf[1],buf[2],buf[3],buf[4],w);		y+=dy; py=3;  break;
			case 3 : scale_6_5_ver_2(y,buf[4],buf[3],buf[2],buf[1],w);		y+=dy; py=4;  break;
			case 4 : scale_6_5_ver_1(y,buf[5],buf[3],buf[2],buf[1],w);		y+=dy; py=0;  break;
		}

		tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;

		if ( !py )
		{
			scale_6_5_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<5; i++) buf[i]=buf[i+1]; buf[5]=tb;
		}
	}
}


static void scale_4_3_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6,x7,x8,x9;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11;
	register uint64	c0,c1,c2,c3,c4,c5;
	register int64	*z;
	register uchar	*q,*p;

	q=x-8;
	p=x-12;
	x-=12;

	lfetch_pre(p);

	c0=rep4(( 96)<<4);
	c1=rep4(( 25)<<4);
	c2=rep4((-11)<<4);
	c3=rep4(( -5)<<4);
	c4=rep4(( 85)<<4);
	c5=rep4(( 58)<<4);

	z=y+1;

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);

	while ( n-- )
	{
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x3), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x2), "r"(x4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x1), "r"(x5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(x2), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x4), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x5), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t11)		: "r"(x4), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t10)		: "r"(x5), "r"(c5)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(q)	: "r"(q)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t4)		: "r"(x1), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);


		asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x0), "r"(x6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x6), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t9)		: "r"(x6), "r"(c4)	);

		asmv("lfetch [%0],16" : "=r"(p) : "r"(p) );

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x8), "r"(c3)	);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t0)		: "r"(t3), "r"(t0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t9), "r"(t10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t7)	);

		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t8)		: "r"(x9), "r"(t8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x4)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(t8), "r"(t11)	);
		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,24"	: "=r"(z)		: "r"(t4), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x5)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(t8), "r"(t9)	);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x6)		);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x7)		);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x8)		);


		asmv("st8		[%0]=%1,8"	: "=r"(y)		: "r"(t8), "r"(y)	);
		asmv("mov		%0=%1"		: "=r"(x5)		: "r"(x9)		);
	}
}


static inline void scale_4_3_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6;
	register uint64	t0,t1,t2,t3,t4,t5,t6;
	register uint64	c0,c1,c2,c3;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( 96)<<2);
	c1=rep4(( 25)<<2);
	c2=rep4((-11)<<2);
	c3=rep4( 64 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x2)	: "r"(x2)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x1)	: "r"(x1)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x1)	: "r"(x1)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x6)	: "r"(x6)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);

		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s5)		: "r"(s5), "r"(c3)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t5)		: "r"(t5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(s3)		: "r"(s5), "r"(s3)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t3)		: "r"(t5), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_4_3_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,long n)
{
	register uint64	s0,s1,s2,s3,s4;
	register uint64	t0,t1,t2,t3,t4;
	register uint64	c0,c1,c2,c3,c4;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( -5)<<2);
	c1=rep4(( 85)<<2);
	c2=rep4(( 58)<<2);
	c3=rep4((-11)<<2);
	c4=rep4( 128 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s0)		: "r"(s0), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t0), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c0)	);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);

		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_4_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[8];
	register int64	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;

	dx*=4;
	px*=4;
	py*=4;
	x+=4*((px/3)+border)+((py/3)+border-3)*dx;
	py%=3;

	tb=((int64 *) tbi)+v;

	for (i=0; i<7; i++)
	{
		buf[i]=tb;
		scale_4_3_hor(tb-v,x,u); x+=dx;
		tb+=3*u;
	}
	buf[7]=tb;

	for (; h; h--)
	{
		scale_4_3_hor(tb-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_4_3_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],w); y+=dy; py=1;  break;
			case 1 : scale_4_3_ver_1(y,buf[0],buf[1],       buf[3],buf[4],buf[5],       w); y+=dy; py=2;  break;
			case 2 : scale_4_3_ver_1(y,buf[7],buf[6],       buf[4],buf[3],buf[2],       w); y+=dy; py=0;  break;
		}

		tb=buf[0]; for (i=0; i<7; i++) buf[i]=buf[i+1]; buf[7]=tb;

		if ( !py )
		{
			scale_4_3_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<7; i++) buf[i]=buf[i+1]; buf[7]=tb;
		}
	}
}

static void scale_3_2_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6;
	register uint64	t0,t1,t2,t3,t4;
	register uint64	c0,c1,c2,c3,c4;
	register int64	*z;
	register uchar	*q,*p;

	q=x-4;
	p=x-8;
	x-=8;

	lfetch_pre(p);

	c0=rep4(( 86)<<4);
	c1=rep4(( 31)<<4);
	c2=rep4((-10)<<4);
	c3=rep4(( 68)<<4);
	c4=rep4(( -4)<<4);

	z=y+1;

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);

	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);

	while ( n-- )
	{
		asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x2), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x1), "r"(x3)	);

		asmv("ld4		%0=[%1],12"	: "=r"(x5),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);

		asmv("ld4		%0=[%1],4"	: "=r"(x6),"=r"(x)	: "r"(x)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x0), "r"(x4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x3), "r"(x4)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x1), "r"(x6)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c4)	);

		asmv("lfetch [%0],12" : "=r"(p) : "r"(p) );

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x3)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x4)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x5) 		);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x6)		);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t3), "r"(z)	);
	}
}

static inline void scale_3_2_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,long n)
{
	register uint64	s0,s1,s2,s3,s4;
	register uint64	t0,t1,t2,t3,t4;
	register uint64	c0,c1,c2,c3;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( 86)<<1);
	c1=rep4(( 31)<<1);
	c2=rep4((-10)<<1);
	c3=rep4( 16 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x0)	: "r"(x0)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x2)	: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("pshr2		%0=%1,5"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,5"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_3_2_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s1,s2,s3;
	register uint64	t0,t1,t2,t3;
	register uint64	c0,c1,c2;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( 68)<<1);
	c1=rep4((- 4)<<1);
	c2=rep4( 16 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x2)	: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("pshr2		%0=%1,5"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c2)	);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("pshr2		%0=%1,5"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_3_2(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[5];
	register int64	*tb;
	register long	i,u,v;

	v=px&1;
	w+=v;
	px-=v;
	u=(w+1)/2;

	dx*=4;
	px*=3;
	py*=3;
	x+=4*((px>>1)+border)+((py>>1)+border-2)*dx;
	py&=1;

	tb=((int64 *) tbi)+v;

	for (i=0; i<4; i++)
	{
		buf[i]=tb;
		scale_3_2_hor(tb-v,x,u); x+=dx;
		tb+=2*u;
	}
	buf[4]=tb;

	for (; h; h--)
	{
		scale_3_2_hor(tb-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_3_2_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],w); y+=dy; py=1;  break;
			case 1 : scale_3_2_ver_1(y,buf[1],buf[2],buf[3],buf[4]       ,w); y+=dy; py=0;  break;
		}

		tb=buf[0]; for (i=0; i<4; i++) buf[i]=buf[i+1]; buf[4]=tb;

		if ( !py )
		{
			scale_3_2_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<4; i++) buf[i]=buf[i+1]; buf[4]=tb;
		}
	}
}

static void scale_5_3_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6,x7,x8,x9;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13;
	register uint64	c0,c1,c2,c3,c4,c5,c6,c7;
	register int64	*z;
	register uchar	*q,*p;

	p=x-12;
	q=x-12;
	x-=8;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);

	c0=rep4(( 78)<<4);
	c1=rep4(( 34)<<4);
	c2=rep4(( -7)<<4);
	c3=rep4(( -2)<<4);
	c4=rep4(( 14)<<4);
	c5=rep4(( 71)<<4);
	c6=rep4(( 55)<<4);
	c7=rep4(( -5)<<4);

	z=y+1;


	while ( n-- )
	{
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x3), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x2), "r"(x4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(x2), "r"(c7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x4), "r"(c6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t9)		: "r"(x4), "r"(c2)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(q)	: "r"(q)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],12"	: "=r"(x8),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x6), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);

		asmv("ld4		%0=[%1],4"	: "=r"(x9),"=r"(x)	: "r"(x)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x1), "r"(x5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x0), "r"(x6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x5), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t10)		: "r"(x5), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t11)		: "r"(x6), "r"(c5)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x7), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t12)		: "r"(x7), "r"(c6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t9), "r"(t10)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t13)		: "r"(x9), "r"(c7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t11)		: "r"(t11), "r"(t12)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t6)	);

		asmv("lfetch [%0],20" : "=r"(p) : "r"(p) );

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t9), "r"(t11)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t9), "r"(t13)	);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,24"	: "=r"(z)		: "r"(t4), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x5)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x6)		);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x7)		);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x8)		);

		asmv("st8		[%0]=%1,8"	: "=r"(y)		: "r"(t9), "r"(y)	);

		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x9)		);
	}
}

static inline void scale_5_3_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6;
	register uint64	t0,t1,t2,t3,t4,t5,t6;
	register uint64	c0,c1,c2,c3,c4;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( 78)<<1);
	c1=rep4(( 34)<<1);
	c2=rep4(( -7)<<1);
	c3=rep4(( -2)<<1);
	c4=rep4( 16 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x1)	: "r"(x1)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c4)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x4)	: "r"(x4)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x5)	: "r"(x5)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c3)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x6)	: "r"(x6)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s5)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c3)	);
		asmv("pshr2		%0=%1,5"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t5)	);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("pshr2		%0=%1,5"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_5_3_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,long n)
{
	register uint64	s0,s1,s2,s3,s4;
	register uint64	t0,t1,t2,t3,t4;
	register uint64	c0,c1,c2,c3,c4,c5;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( -7)<<1);
	c1=rep4(( 14)<<1);
	c2=rep4(( 71)<<1);
	c3=rep4(( 55)<<1);
	c4=rep4(( -5)<<1);
	c5=rep4( 16 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);

		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c5)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("pshr2		%0=%1,5"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,5"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


void scale_5_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[7];
	register int64	*tb;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;

	dx*=4;
	px*=5;
	py*=5;
	x+=4*((px/3)+border)+((py/3)+border-3)*dx;
	py%=3;

	tb=((int64 *) tbi)+v;

	for (i=0; i<6; i++)
	{
		buf[i]=tb;
		scale_5_3_hor(tb-v,x,u); x+=dx;
		tb+=3*u;
	}
	buf[6]=tb;

	for (; h; h--)
	{
		scale_5_3_hor(tb-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_5_3_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],w); y+=dy; py=2;  break;
			case 1 : scale_5_3_ver_1(y,buf[1],buf[2],buf[3],buf[4],buf[6],w);		y+=dy; py=0;  break;
			case 2 : scale_5_3_ver_1(y,buf[6],buf[5],buf[4],buf[3],buf[1],w);		y+=dy; py=1;  break;
		}

		tb=buf[0]; for (i=0; i<6; i++) buf[i]=buf[i+1]; buf[6]=tb;

		if ( py!=2 )
		{
			scale_5_3_hor(tb-v,x,u); x+=dx;
			tb=buf[0]; for (i=0; i<6; i++) buf[i]=buf[i+1]; buf[6]=tb;
		}
	}
}


static void scale_2_1_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7;
	register uint64	c0,c1;
	register int64	*z;
	register uchar	*q,*p;

	p=x-12;
	q=x-4;
	x-=12;

	lfetch_pre(p);

	c0=rep4(( 19)<<5);
	c1=rep4(( -3)<<5);

	asmv("ld4		%0=[%1],12"	: "=r"(x0),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);

	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);

	z=y+2;

	while ( n-- )
	{
		asmv("lfetch [%0],32" : "=r"(p) : "r"(p) );

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(x2), "r"(x4)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(q)	: "r"(q)		);

		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x10),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x4), "r"(x6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x0), "r"(x6)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x11),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x12),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x6), "r"(x8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(x2), "r"(x8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c1)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x12)		: "r"(x12) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x8), "r"(x10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(x4), "r"(x10)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(x6), "r"(x12)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t5)	);
		asmv("pshladd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(x3), "r"(t0)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t6)	);
		asmv("pshladd2		%0=%1,3,%2"	: "=r"(t1)		: "r"(x5), "r"(t1)	);
		asmv("st8		[%0]=%1,32"	: "=r"(y)		: "r"(t0), "r"(y)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t7)	);
		asmv("pshladd2		%0=%1,3,%2"	: "=r"(t2)		: "r"(x7), "r"(t2)	);
		asmv("st8		[%0]=%1,32"	: "=r"(z)		: "r"(t1), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x8)		);

		asmv("pshladd2		%0=%1,3,%2"	: "=r"(t3)		: "r"(x9), "r"(t3)	);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x10)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x11) 		);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x12)		);
		asmv("st8		[%0]=%1,32"	: "=r"(y)		: "r"(t2), "r"(y)	);

		asmv("st8		[%0]=%1,32"	: "=r"(z)		: "r"(t3), "r"(z)	);
	}
}


static inline void scale_2_1_ver(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s2,s3,s4,s6;
	register uint64	t0,t2,t3,t4,t6;
	register uint64	c0,c1,c2;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( 19)<<2);
	c1=rep4(( -3)<<2);
	c2=rep4( 16 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],16"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(s4),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],16"	: "=r"(s6),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t4),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t6),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x1)	: "r"(x1)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pshr2		%0=%1,5"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,5"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_2_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register int64	*tb0,*tb1,*tb2,*tb3, *ttb;
	register long	i,u;

	dx*=4;
	x+=4*(2*px+border)+(2*py+border-3)*dx;

	u=(w+3)>>2;

	tb0=(int64 *) tbi;
	tb1=tb0+8*u;	for (i=0; i<2; i++) { scale_2_1_hor(tb0+i,x,u); x+=dx; }
	tb2=tb1+8*u;	for (i=0; i<2; i++) { scale_2_1_hor(tb1+i,x,u); x+=dx; }
	tb3=tb2+8*u;	for (i=0; i<2; i++) { scale_2_1_hor(tb2+i,x,u); x+=dx; }

	do
	{
		scale_2_1_hor(tb3  ,x,u); x+=dx;
		scale_2_1_hor(tb3+1,x,u); x+=dx;
		scale_2_1_ver(y,tb0,tb1,tb2,tb3,w); y+=dy;
		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;
		h--;
	}
	while ( h );
}


static void scale_9_4_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18,t19,t20;
	register uint64	c0,c1,c2,c3,c4,c5,c6,c7,c8;
	register int64	*z;
	register uchar	*q,*p;

	q=x-12;
	p=x-16;
	x-=16;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);


	c0=rep4((114)<<4);
	c1=rep4(( 73)<<4);
	c2=rep4(( 56)<<4);
	c3=rep4((110)<<4);
	c4=rep4(( 89)<<4);
	c5=rep4(( 22)<<4);
	c6=rep4((102)<<4);
	c7=rep4(( 38)<<4);
	c8=rep4(( -6)<<4);

	z=y+1;


	while ( n-- )
	{
		asmv("lfetch [%0],36" : "=r"(p) : "r"(p) );

		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(q)	: "r"(q)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(q)	: "r"(q)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x10),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x11),"=r"(q)	: "r"(q)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x12),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],12"	: "=r"(x13),"=r"(q)	: "r"(q)		);
		asmv("ld4		%0=[%1],4"	: "=r"(x14),"=r"(x)	: "r"(x)		);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x11)		: "r"(x11) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x12)		: "r"(x12) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x13)		: "r"(x13) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x14)		: "r"(x14) 		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x4), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x3), "r"(x5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x2), "r"(x6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x1), "r"(x7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x0), "r"(x8)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t5)		: "r"(x10), "r"(x3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x5), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x6), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x7), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t9)		: "r"(x8), "r"(c5)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t10)		: "r"(x9), "r"(x9)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t11)		: "r"(x8), "r"(x9)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t12)		: "r"(x7), "r"(x10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t13)		: "r"(x6), "r"(x11)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t14)		: "r"(x5), "r"(x12)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t15)		: "r"(x7), "r"(x14)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t16)		: "r"(x8), "r"(x8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t17)		: "r"(x9), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t18)		: "r"(x10), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t19)		: "r"(x11), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t20)		: "r"(x12), "r"(c2)	);


		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t3), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(t8), "r"(t9)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t11)		: "r"(t11), "r"(c6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t12)		: "r"(t12), "r"(c7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t13)		: "r"(t13), "r"(t14)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t15)		: "r"(t15), "r"(t16)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t17)		: "r"(t17), "r"(t18)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t19)		: "r"(t19), "r"(t20)	);


		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t2)		: "r"(t2), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t11)		: "r"(t11), "r"(t12)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t13)		: "r"(t13), "r"(c8)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t17)		: "r"(t17), "r"(t15)	);


		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t2)		: "r"(t4), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t11)		: "r"(t11), "r"(t13)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t17)		: "r"(t17), "r"(t19)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);

		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x9)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x10)		);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x11)		);

		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t6), "r"(z)	);
		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t11), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t17), "r"(z)	);

		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x12)		);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x13)		);
		asmv("mov		%0=%1"		: "=r"(x5)		: "r"(x14)		);
	}
}


static inline void scale_9_4_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,int64 *x7,int64 *x8,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6,s7,s8;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8;
	register uint64	c0,c1,c2,c3,c4;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4((114));
	c1=rep4(( 73));
	c2=rep4((  9));
	c3=rep4(( -2));
	c4=rep4( 32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s7),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s8),"=r"(x8)	: "r"(x8)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t8),"=r"(x8)	: "r"(x8)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s7)		: "r"(s7), "r"(s8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s5)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s7)		: "r"(s7), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_9_4_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6;
	register uint64	t0,t1,t2,t3,t4,t5,t6;
	register uint64	c0,c1,c2,c3,c4,c5,c6,c7;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( -8));
	c1=rep4(( 56));
	c2=rep4((110));
	c3=rep4(( 89));
	c4=rep4(( 22));
	c5=rep4(( -9));
	c6=rep4(( -4));
	c7=rep4( 32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x6)	: "r"(x6)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s6)		: "r"(s6), "r"(c6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


static inline void scale_9_4_ver_2(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,int64 *x7,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6,s7;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7;
	register uint64	c0,c1,c2,c3;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4((102));
	c1=rep4(( 38));
	c2=rep4(( -6));
	c3=rep4( 32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s7),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x7)	: "r"(x7)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s6)		: "r"(s6), "r"(s7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c3)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_9_4(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[9];
	register int64	*tb0,*tb1,*tbh;
	register long	i,u,v;

	v=px&3;
	w+=v;
	px-=v;
	u=(w+3)>>2;

	dx*=4;
	px*=9;
	py*=9;
	x+=4*((px>>2)+border)+((py>>2)+border-4)*dx;
	py&=3;

	tb0=((int64 *) tbi)+v;

	for (i=0; i<7; i++)
	{
		buf[i]=tb0;
		scale_9_4_hor(tb0-v,x,u); x+=dx;
		tb0+=4*u;
	}
	buf[7]=tb0;	tb1=tb0+4*u;
	buf[8]=tb1;

	for (; h; h--)
	{
		scale_9_4_hor(tb0-v,x,u); x+=dx;
		scale_9_4_hor(tb1-v,x,u); x+=dx;

		switch ( py ) {
			case 0 : scale_9_4_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);	y+=dy; py=1;	break;
			case 1 : scale_9_4_ver_1(y,buf[1],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);			y+=dy; py=2;	break;
			case 2 : scale_9_4_ver_2(y,buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);		y+=dy; py=3;	break;
			case 3 : scale_9_4_ver_1(y,buf[8],buf[6],buf[5],buf[4],buf[3],buf[2],buf[1],w);			y+=dy; py=0;	break;
		}

		if ( py )
		{
			tb0=buf[0];
			tb1=buf[1];
			for (i=0; i<7; i++) buf[i]=buf[i+2];
			buf[7]=tb0;
			buf[8]=tb1;
		}
		else
		{
			tbh=buf[0];
			tb0=buf[1];
			tb1=buf[2];
			for (i=0; i<6; i++) buf[i]=buf[i+3];
			buf[6]=tbh;
			buf[7]=tb0;
			buf[8]=tb1;
			scale_9_4_hor(tbh-v,x,u); x+=dx;
		}
	}
}

static void scale_5_2_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8;
	register uint64	c0,c1,c2,c3,c4,c5,c6;
	register int64	*z;
	register uchar	*q,*p;

	q=x-12;
	p=x-12;
	x-=8;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);

	c0=rep4(( 52)<<4);
	c1=rep4(( 36)<<4);
	c2=rep4((  9)<<4);
	c3=rep4(( -4)<<4);
	c4=rep4(( -3)<<4);
	c5=rep4(( 47)<<4);
	c6=rep4(( 22)<<4);

	z=y+1;


	while ( n-- )
	{
		asmv("lfetch [%0],20" : "=r"(p) : "r"(p) );

		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(q)	: "r"(q)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],12"	: "=r"(x10),"=r"(q)	: "r"(q)		);
		asmv("ld4		%0=[%1],4"	: "=r"(x11),"=r"(x)	: "r"(x)		);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x11)		: "r"(x11) 		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x4), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x3), "r"(x5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x2), "r"(x6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x1), "r"(x7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x0), "r"(x8)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(x6), "r"(x7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(x5), "r"(x8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(x3), "r"(x10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(x2), "r"(x11)	);


		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c4)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c3)	);
		asmv("pshr2		%0=%1,7"	: "=r"(t8)		: "r"(t8)		);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t8)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t7)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);


		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,16"	: "=r"(z)		: "r"(t5), "r"(z)	);

		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x5)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x6)		);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x7)		);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x8)		);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x9)		);
		asmv("mov		%0=%1"		: "=r"(x5)		: "r"(x10)		);
		asmv("mov		%0=%1"		: "=r"(x6)		: "r"(x11)		);

	}
}

static inline void scale_5_2_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,int64 *x7,int64 *x8,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6,s7,s8;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8;
	register uint64	c0,c1,c2,c3,c4,c5;
	register uchar	*z;

	z=y+4;

	c0=rep4(( 52)<<2);
	c1=rep4(( 36)<<2);
	c2=rep4((  9)<<2);
	c3=rep4(( -4)<<2);
	c4=rep4(( -3)<<2);
	c5=rep4( 32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s7),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s8),"=r"(x8)	: "r"(x8)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t8),"=r"(x8)	: "r"(x8)		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s7)		: "r"(s7), "r"(s8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s7)		: "r"(s7), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_5_2_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,int64 *x7,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6,s7;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7;
	register uint64	c0,c1,c2, c3;
	register uchar	*z;

	z=y+4;

	c0=rep4(( 47)<<2);
	c1=rep4(( 22)<<2);
	c2=rep4( -32 );

	c3=rep4((  1)<<2);

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s7),"=r"(x7)	: "r"(x7)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x7)	: "r"(x7)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s6)		: "r"(s6), "r"(s7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c1)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s4)		: "r"(s4), "r"(c2)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t4)		: "r"(t4), "r"(c2)	);
		asmv("pshr2		%0=%1,5"	: "=r"(s6)		: "r"(s6)		);
		asmv("pshr2		%0=%1,5"	: "=r"(t6)		: "r"(t6)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t6)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s4)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_5_2(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[10];
	register int64	*tb0,*tb1,*tbh;
	register long	i,u,v;

	v=px&1;
	w+=v;
	px-=v;
	u=(w+1)>>1;


	dx*=4;
	px*=5;
	py*=5;
	x+=4*((px>>1)+border)+((py>>1)+border-4)*dx;
	py&=1;

	tb0=((int64 *) tbi)+v;
	for (i=0; i<8; i++)
	{
		buf[i]=tb0;
		scale_5_2_hor(tb0-v,x,u); x+=dx;
		tb0+=2*u;
	}
	buf[8]=tb0;	tb1=tb0+2*u;
	buf[9]=tb1;

	for (; h; h--)
	{
		scale_5_2_hor(tb0-v,x,u); x+=dx;
		scale_5_2_hor(tb1-v,x,u); x+=dx;
		
		switch ( py ) {
			case 0 : scale_5_2_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],u);	y+=dy; py=1; 
				 tb0=buf[0];
				 tb1=buf[1];
				 for (i=0; i<8; i++) buf[i]=buf[i+2];
				 buf[8]=tb0;
				 buf[9]=tb1;
				 continue;

			case 1 : scale_5_2_ver_1(y,buf[0],buf[1],buf[3],buf[4],buf[5],buf[6],buf[8],buf[9],u);		y+=dy; py=0;
				 tbh=buf[0];
				 tb0=buf[1];
				 tb1=buf[2];
				 for (i=0; i<7; i++) buf[i]=buf[i+3];
				 buf[7]=tbh;
				 buf[8]=tb0;
				 buf[9]=tb1;
				 scale_5_2_hor(tbh-v,x,u); x+=dx;
				 continue;
		}
	}
}


static void scale_8_3_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18;
	register uint64	c0,c1,c2,c3,c4,c5,c6,c7,c8,c9;
	register int64	*z;
	register uchar	*q, *p;

	q=x-12;
	p=x-16;
	x-=16;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x1),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);

	c0=rep4(( 96)<<4);
	c1=rep4(( 70)<<4);
	c2=rep4(( 21)<<4);
	c3=rep4(( -5)<<4);
	c4=rep4(( -6)<<4);
	c5=rep4(( -7)<<4);
	c6=rep4(( 37)<<4);
	c7=rep4(( 83)<<4);
	c8=rep4(( 92)<<4);
	c9=rep4(( 54)<<4);

	z=y+1;

	while ( n-- )
	{
		asmv("lfetch [%0],32" : "=r"(p) : "r"(p) );

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x4), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x3), "r"(x5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x3), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(x5), "r"(c6)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(q)	: "r"(q)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x10),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x11),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x2), "r"(x6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x1), "r"(x7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(x6), "r"(c7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(x7), "r"(c8)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t12)		: "r"(x5), "r"(x6)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t13)		: "r"(x7), "r"(x7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x12),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x13),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x11)		: "r"(x11) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x0), "r"(x8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t9)		: "r"(x8), "r"(c9)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t10)		: "r"(x9), "r"(x9)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t14)		: "r"(x8), "r"(c9)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t15)		: "r"(x9), "r"(c8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t8)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x13)		: "r"(x13) 		);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t11)		: "r"(x11), "r"(x10)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t16)		: "r"(x10), "r"(c7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t17)		: "r"(x11), "r"(c6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c4)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t12)		: "r"(t13), "r"(t12)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t9), "r"(t10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t14)		: "r"(t14), "r"(t15)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t18)		: "r"(x13), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t16)		: "r"(t16), "r"(t17)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(t9), "r"(t11)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t12)		: "r"(t12), "r"(t14)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t16)		: "r"(t16), "r"(t18)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t9)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t12)		: "r"(t12), "r"(t16)	);
		asmv("st8		[%0]=%1,16"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("st8		[%0]=%1,24"	: "=r"(z)		: "r"(t5), "r"(z)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x8)		);
		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x9)		);
		asmv("mov		%0=%1"		: "=r"(x2)		: "r"(x10)		);

		asmv("st8		[%0]=%1,8"	: "=r"(y)		: "r"(t12), "r"(y)	);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x11)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x12) 		);
		asmv("mov		%0=%1"		: "=r"(x5)		: "r"(x13)		);

	}
}

static inline void scale_8_3_ver_0(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,int64 *x7,int64 *x8,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6,s7,s8;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8;
	register uint64	c0,c1,c2,c3,c4,c5;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4(( 96));
	c1=rep4(( 70));
	c2=rep4(( 21));
	c3=rep4(( -5));
	c4=rep4(( -6));
	c5=rep4( 32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s7),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s8),"=r"(x8)	: "r"(x8)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x7)	: "r"(x7)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t8),"=r"(x8)	: "r"(x8)		);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s0)		: "r"(s0), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s5)		: "r"(s5), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s7)		: "r"(s7), "r"(s8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(c5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s7)		: "r"(s7), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t7)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

static inline void scale_8_3_ver_1(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,int64 *x4,int64 *x5,int64 *x6,int64 *x7,long n)
{
	register uint64	s0,s1,s2,s3,s4,s5,s6,s7;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7;
	register uint64	c0,c1,c2,c3,c4,c5,c6;
	register uchar	*z;

	z=y+4;
	n=(n+1)>>1;

	c0=rep4((  9));
	c1=rep4(( 54));
	c2=rep4(( 92));
	c3=rep4(( 83));
	c4=rep4(( 37));
	c5=rep4(( -7));
	c6=rep4( -64 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s1),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s7),"=r"(x7)	: "r"(x7)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t2),"=r"(x2)	: "r"(x2)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x4)	: "r"(x4)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x5)	: "r"(x5)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x6)	: "r"(x6)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x7)	: "r"(x7)		);

		asmv("pshr2		%0=%1,5"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,5"	: "=r"(t0)		: "r"(t0)		);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s1)		: "r"(s1), "r"(c6)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t1)		: "r"(t1), "r"(c6)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s2)		: "r"(s2), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s6)		: "r"(s6), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c4)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s7)		: "r"(s7), "r"(c5)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c5)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(s0)		: "r"(s1), "r"(s0)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s2)		: "r"(s2), "r"(s3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t5)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s6)		: "r"(s6), "r"(s7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t7)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s2), "r"(s0)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t2), "r"(t0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t4)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);
		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);
		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}


void scale_8_3(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	int64		*buf[9];
	register int64	*tb0,*tb1,*tbh;
	register long	i,u,v;

	v=px%3;
	w+=v;
	px-=v;
	u=(w+2)/3;

	dx*=4;
	px*=8;
	py*=8;
	x+=4*((px/3)+border)+((py/3)+border-4)*dx;
	py%=3;

	tb0=((int64 *) tbi)+v;

	for (i=0; i<7; i++)
	{
		buf[i]=tb0;
		scale_8_3_hor(tb0-v,x,u); x+=dx;
		tb0+=3*u;
	}
	tb1=tb0+3*u;

	for (; h; h--)
	{
		buf[7]=tb0;
		buf[8]=tb1;

		scale_8_3_hor(tb0-v,x,u); x+=dx;
		scale_8_3_hor(tb1-v,x,u); x+=dx;

		switch ( py ) {
			case 0 : scale_8_3_ver_0(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],w);	y+=dy; py=2;
				 tb0=buf[0];
				 tb1=buf[1];
				 for (i=0; i<7; i++) buf[i]=buf[i+2];
				 continue;

			case 1 : scale_8_3_ver_1(y,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[8],w);		y+=dy; py=0;

			case 2 : tbh=buf[0];
				 tb0=buf[1];
				 tb1=buf[2];
				 for (i=0; i<6; i++) buf[i]=buf[i+3];
				 buf[6]=tbh;
				 scale_8_3_hor(tbh-v,x,u); x+=dx;
				 if ( !py ) continue;

				 scale_8_3_ver_1(y,tbh,buf[5],buf[4],buf[3],buf[2],buf[1],buf[0],tb0,w);		y+=dy; py=1;
				 continue;
		}
	}
}


static void scale_3_1_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x3,x4,x5,x6,x7,x8,x9,x10,x12,x13;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7,t8,t9;
	register uint64	c0,c1,c2,c3;
	register int64	*z;
	register uchar	*q,*p;

	p=x-20;
	q=x-20;
	x-=16;

	lfetch_pre(p);

	asmv("ld4		%0=[%1],12"	: "=r"(x0),"=r"(q)	: "r"(x)		);
	asmv("ld4		%0=[%1],12"	: "=r"(x1),"=r"(x)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x3),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x3)		: "r"(x3) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);

	c0=rep4(( 86)<<4);
	c1=rep4(( 68)<<4);
	c2=rep4(( 31)<<4);
	c3=rep4(( 10)<<4);

	z=y+3;

	while ( n-- )
	{
		asmv("lfetch [%0],24" : "=r"(p) : "r"(p) );

		asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(q)	: "r"(q)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(x5), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(x4), "r"(x6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x3), "r"(x7)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x10),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x12),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x13),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(x8), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(x7), "r"(x9)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x12)		: "r"(x12) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x13)		: "r"(x13) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x1), "r"(x9)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x0), "r"(x10)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c1)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t8)		: "r"(x4), "r"(x12)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(x6), "r"(x10)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c3)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t2)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(t8), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t9)		: "r"(x3), "r"(x13)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t3)		: "r"(t4), "r"(t3)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t7)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t8)		: "r"(t9), "r"(t8)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("mov		%0=%1"		: "=r"(x0)		: "r"(x6)		);

		asmv("mov		%0=%1"		: "=r"(x1)		: "r"(x7)		);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t8)	);
		asmv("mov		%0=%1"		: "=r"(x3)		: "r"(x9)		);
		asmv("mov		%0=%1"		: "=r"(x4)		: "r"(x10)		);
		asmv("st8		[%0]=%1,48"	: "=r"(y)		: "r"(t0), "r"(y)	);

		asmv("mov		%0=%1"		: "=r"(x6)		: "r"(x12)		);
		asmv("mov		%0=%1"		: "=r"(x7)		: "r"(x13)		);

		asmv("st8		[%0]=%1,48"	: "=r"(z)		: "r"(t5), "r"(z)	);
	}
}

static inline void scale_3_1_ver(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	s0,s1,s3,s4,s5,s6,s7,s9,s10;
	register uint64	t0,t1,t3,t4,t5,t6,t7,t9,t10;
	register uint64	c0,c1,c2,c3,c4;
	register uchar	*z;

	z=y+4;

	c0=rep4(( 86));
	c1=rep4(( 68));
	c2=rep4(( 31));
	c3=rep4(( 10));
	c4=rep4(-128);

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(s3),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s6),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(s4),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(s7),"=r"(x2)	: "r"(x2)		);


		asmv("ld8		%0=[%1],8"	: "=r"(s5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s0),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s4)		: "r"(s4), "r"(s6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s7)	);


		asmv("ld8		%0=[%1],8"	: "=r"(t3),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x2)	: "r"(x2)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s5)		: "r"(s5), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s4)		: "r"(s4), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s3)		: "r"(s3), "r"(c2)	);


		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t7),"=r"(x2)	: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s3)		: "r"(s3), "r"(s4)	);


		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(s9),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t6)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t7)	);


		asmv("ld8		%0=[%1],16"	: "=r"(s1),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],16"	: "=r"(s10),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c0)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t4)		: "r"(t4), "r"(c1)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);


		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t9),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s1)		: "r"(s1), "r"(s9)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t4)	);


		asmv("ld8		%0=[%1],16"	: "=r"(t1),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t10),"=r"(x3)	: "r"(x3)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(s1)		: "r"(s1), "r"(c3)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(s0)		: "r"(s0), "r"(c4)	);


		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t9)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t10)	);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(s0)		: "r"(s0), "r"(s1)	);


		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c3)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t0), "r"(c4)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s3), "r"(s0)	);

		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(s0)		: "r"(s0), "r"(s5)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t3), "r"(t0)	);
		asmv("pshr2		%0=%1,6"	: "=r"(s0)		: "r"(s0)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t5)	);
		asmv("pack2.uss		%0=%1,r0"	: "=r"(s0)		: "r"(s0)		);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);
		asmv("st4		[%0]=%1,8"	: "=r"(y)		: "r"(s0), "r"(y)	);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,8"	: "=r"(z)		: "r"(t0), "r"(z)	);
	}
}

void scale_3_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register int64	*tb0,*tb1,*tb2,*tb3, *ttb;
	register long	i,u;

	dx*=4;
	x+=4*(3*px+border)+(3*py+border-5)*dx;
	u=(w+1)>>1;

	tb0=(int64 *) tbi;
	tb1=tb0+6*u;	for (i=0; i<3; i++) { scale_3_1_hor(tb0+i,x,u); x+=dx; }
	tb2=tb1+6*u;	for (i=0; i<3; i++) { scale_3_1_hor(tb1+i,x,u); x+=dx; }
	tb3=tb2+6*u;	for (i=0; i<3; i++) { scale_3_1_hor(tb2+i,x,u); x+=dx; }

	do
	{
		for (i=0; i<3; i++) { scale_3_1_hor(tb3+i,x,u); x+=dx; }

		scale_3_1_ver(y,tb0,tb1,tb2,tb3,u); y+=dy;

		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;

		h--;
	}
	while ( h );
}


static void scale_4_1_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14;
	register uint64	t0,t1,t3,t4;
	register uint64	c0,c1,c2;
	register uchar	*q, *p;

	p=x-28;
	q=x-28;
	x-=24;

	lfetch_pre(p);

	c0=rep4(( 28)<<4);
	c1=rep4((-19)<<4);
	c2=rep4(( -3)<<4);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],16"	: "=r"(x1),"=r"(x)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x2),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x10),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);

	asmv("padd2.sss		%0=%1,%2"	: "=r"(x1)		: "r"(x1), "r"(x2)	);
	asmv("padd2.sss		%0=%1,%2"	: "=r"(x4)		: "r"(x4), "r"(x10)	);
	asmv("padd2.sss		%0=%1,%2"	: "=r"(x9)		: "r"(x5), "r"(x9)	);

	asmv("pshladd2		%0=%1,2,%2"	: "=r"(x7)		: "r"(x7), "r"(x4)	);

	while ( n-- )
	{
		asmv("lfetch [%0],16" : "=r"(p) : "r"(p) );

		asmv("ld4		%0=[%1],8"	: "=r"(x11),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x12),"=r"(q)	: "r"(q)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(x6), "r"(x8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(x9), "r"(c1)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x13),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x14),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x11)		: "r"(x11) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x12)		: "r"(x12) 		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t0)		: "r"(t0), "r"(c0)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(x1), "r"(x12)	);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x13)		: "r"(x13) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x14)		: "r"(x14) 		);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(x13)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x0), "r"(x14)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(x7)	);

		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(t3), "r"(c2)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t4), "r"(t0)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(x0)		: "r"(x4), "r"(x10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(x1)		: "r"(x5), "r"(x6)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t3), "r"(t0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(x4)		: "r"(x8), "r"(x14)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(x5)		: "r"(x9), "r"(x5)	);

		asmv("st8		[%0]=%1,32"	: "=r"(y)		: "r"(t0), "r"(y)	);
		asmv("mov		%0=%1"		: "=r"(x6)		: "r"(x10)		);
		asmv("pshladd2		%0=%1,2,%2"	: "=r"(x7)		: "r"(x11), "r"(x4)	);
		asmv("mov		%0=%1"		: "=r"(x8)		: "r"(x12)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(x9)		: "r"(x5), "r"(x13)	);
		asmv("mov		%0=%1"		: "=r"(x10)		: "r"(x14)		);
	}
}


static inline void scale_4_1_ver(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	t0,t1,t2,t4,t5,t6,t7,t8,t9,t10,t12,t13,t14;
	register uint64	c0,c1,c2,c3;

	c0=rep4(( 28)<<2);
	c1=rep4(( 19)<<2);
	c2=rep4(( -3)<<2);
	c3=rep4( 128 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t8),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t9),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t10),"=r"(x2)	: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t9)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t8)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t10)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t12),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x0)	: "r"(x0)		);
		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t7)		: "r"(t4), "r"(t7)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c0)	);


		asmv("ld8		%0=[%1],8"	: "=r"(t13),"=r"(x3)	: "r"(x3)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t2),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);

		asmv("ld8		%0=[%1],16"	: "=r"(t14),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(t2), "r"(t12)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t13)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t14)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);

		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t0), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c2)	);

		asmv("pshradd2		%0=%1,2,%2"	: "=r"(t0)		: "r"(t0), "r"(t7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t5)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,4"	: "=r"(y)		: "r"(t0), "r"(y)	);
	}
}

void scale_4_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register int64	*tb0,*tb1,*tb2,*tb3,*ttb;
	register long	i;

	dx*=4;
	x+=4*(4*px+border)+(4*py+border-7)*dx;

	tb0=(int64 *) tbi;
	tb1=tb0+4*w;	for (i=0; i<4; i++) { scale_4_1_hor(tb0+i,x,w); x+=dx; }
	tb2=tb1+4*w;	for (i=0; i<4; i++) { scale_4_1_hor(tb1+i,x,w); x+=dx; }
	tb3=tb2+4*w;	for (i=0; i<4; i++) { scale_4_1_hor(tb2+i,x,w); x+=dx; }

	do
	{
		for (i=0; i<4; i++) { scale_4_1_hor(tb3+i,x,w); x+=dx; }

		scale_4_1_ver(y,tb0,tb1,tb2,tb3,w); y+=dy;

		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;

		h--;
	}
	while ( h );
}


static void scale_5_1_hor(int64 *y,uchar *x,long n)
{
	register uint64	x0,x1,x2,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16;
	register uint64	t0,t1,t2,t3,t4,t5,t6,t7;
	register uint64	c0,c1,c2,c3,c4;
	register uchar	*q, *p;

	p=x-32;
	q=x-32;
	x-=28;

	lfetch_pre(p);

	c0=rep4((-50)<<4);
	c1=rep4((-46)<<3);
	c2=rep4(( 35)<<3);
	c3=rep4(( 21)<<3);
	c4=rep4(( -3)<<3);

	asmv("ld4		%0=[%1],8"	: "=r"(x0),"=r"(q)	: "r"(x)		);
	asmv("ld4		%0=[%1],12"	: "=r"(x1),"=r"(x)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x0)		: "r"(x0) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x1)		: "r"(x1) 		);
	asmv("ld4		%0=[%1],12"	: "=r"(x2),"=r"(q)	: "r"(x)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x4),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x2)		: "r"(x2) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x4)		: "r"(x4) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x5),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x6),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x5)		: "r"(x5) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x6)		: "r"(x6) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x7),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x8),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x7)		: "r"(x7) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x8)		: "r"(x8) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x9),"=r"(q)	: "r"(q)		);
	asmv("ld4		%0=[%1],8"	: "=r"(x10),"=r"(x)	: "r"(x)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x9)		: "r"(x9) 		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x10)		: "r"(x10) 		);
	asmv("ld4		%0=[%1],8"	: "=r"(x11),"=r"(q)	: "r"(q)		);
	asmv("unpack1.l		%0=r0,%1"	: "=r"(x11)		: "r"(x11) 		);

	asmv("padd2.sss		%0=%1,%2"	: "=r"(x1)		: "r"(x1), "r"(x2)	);
	asmv("padd2.sss		%0=%1,%2"	: "=r"(x5)		: "r"(x5), "r"(x11)	);
	asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(x8)		: "r"(x8), "r"(c0)	);
	asmv("padd2.sss		%0=%1,%2"	: "=r"(x9)		: "r"(x9), "r"(x7)	);


	while ( n-- )
	{
		asmv("lfetch [%0],20" : "=r"(p) : "r"(p) );

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t2)		: "r"(x6), "r"(x10)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t3)		: "r"(x5), "r"(c3)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(x9), "r"(c1)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x12),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],8"	: "=r"(x13),"=r"(q)	: "r"(q)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t2)		: "r"(t2), "r"(c2)	);

		asmv("ld4		%0=[%1],8"	: "=r"(x14),"=r"(x)	: "r"(x)		);
		asmv("ld4		%0=[%1],12"	: "=r"(x15),"=r"(q)	: "r"(q)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x12)		: "r"(x12) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x13)		: "r"(x13) 		);

		asmv("ld4		%0=[%1],4"	: "=r"(x16),"=r"(x)	: "r"(x)		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x14)		: "r"(x14) 		);
		asmv("unpack1.l		%0=r0,%1"	: "=r"(x15)		: "r"(x15) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(x4), "r"(x12)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(x14), "r"(x15)	);

		asmv("unpack1.l		%0=r0,%1"	: "=r"(x16)		: "r"(x16) 		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(x1), "r"(t6)	);
		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t2)		: "r"(t4), "r"(t2)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(x4)		: "r"(x9), "r"(x7)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(x0), "r"(x16)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c4)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(x1)		: "r"(x6), "r"(x7)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(x9)		: "r"(x14), "r"(x12)	);

		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t7), "r"(x8)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(x0)		: "r"(x5), "r"(x11)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t3)		: "r"(t3), "r"(t5)	);
		asmv("mov		%0=%1"		: "=r"(x6)		: "r"(x11)		);

		asmv("pshradd2		%0=%1,1,%2"	: "=r"(t0)		: "r"(t0), "r"(t1)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(x5)		: "r"(x10), "r"(x16)	);
		asmv("mov		%0=%1"		: "=r"(x7)		: "r"(x12)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(x8)		: "r"(x13), "r"(c0)	);

		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t2), "r"(t0)	);
		asmv("mov		%0=%1"		: "=r"(x10)		: "r"(x15)		);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t3)	);
		asmv("mov		%0=%1"		: "=r"(x11)		: "r"(x16)		);

		asmv("st8		[%0]=%1,40"	: "=r"(y)		: "r"(t0), "r"(y)	);
	}
}

static inline void scale_5_1_ver(uchar *y,int64 *x0,int64 *x1,int64 *x2,int64 *x3,long n)
{
	register uint64	t0,t1,t2,t4,t5,t6,t7,t8,t9,t10,t11,t12,t14,t15,t16;
	register uint64	c0,c1,c2,c3,c4,c5;

	c0=rep4(( 50)<<1);
	c1=rep4((-46)<<1);
	c2=rep4(( 35)<<1);
	c3=rep4(( 21)<<1);
	c4=rep4(( -3)<<1);
	c5=rep4( -8*32 );

	while ( n-- )
	{
		asmv("ld8		%0=[%1],8"	: "=r"(t5),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t10),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t6),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t11),"=r"(x2)	: "r"(x2)		);

		asmv("ld8		%0=[%1],8"	: "=r"(t7),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],16"	: "=r"(t12),"=r"(x2)	: "r"(x2)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t6)		: "r"(t6), "r"(t10)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t11)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t8),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t14),"=r"(x2)	: "r"(x2)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t6)		: "r"(t6), "r"(c2)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t5)		: "r"(t5), "r"(c3)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t9),"=r"(x1)	: "r"(x1)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t0),"=r"(x0)	: "r"(x0)		);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t8)		: "r"(t8), "r"(c0)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t6)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t1),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],8"	: "=r"(t15),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t7)		: "r"(t7), "r"(t9)	);

		asmv("ld8		%0=[%1],16"	: "=r"(t2),"=r"(x0)	: "r"(x0)		);
		asmv("ld8		%0=[%1],32"	: "=r"(t16),"=r"(x3)	: "r"(x3)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t14)		: "r"(t14), "r"(t15)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t7)		: "r"(t7), "r"(c1)	);

		asmv("ld8		%0=[%1],8"	: "=r"(t4),"=r"(x0)	: "r"(x0)		);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t2)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t16)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t4)		: "r"(t4), "r"(t12)	);
		asmv("padd2.sss		%0=%1,%2"	: "=r"(t1)		: "r"(t1), "r"(t14)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t0), "r"(c5)	);

		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t8)		: "r"(t4), "r"(t8)	);
		asmv("pmpyshr2		%0=%1,%2,7"	: "=r"(t1)		: "r"(t1), "r"(c4)	);
		asmv("pshradd2		%0=%1,3,%2"	: "=r"(t0)		: "r"(t0), "r"(t7)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t5)		: "r"(t5), "r"(t8)	);
		asmv("psub2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t1), "r"(t0)	);

		asmv("padd2.sss		%0=%1,%2"	: "=r"(t0)		: "r"(t0), "r"(t5)	);

		asmv("pshr2		%0=%1,6"	: "=r"(t0)		: "r"(t0)		);

		asmv("pack2.uss		%0=%1,r0"	: "=r"(t0)		: "r"(t0)		);

		asmv("st4		[%0]=%1,4"	: "=r"(y)		: "r"(t0), "r"(y)	);
	}
}

void scale_5_1(int *tbi,uchar *y,long dy,uchar *x,long dx,long px,long py,long w,long h)
{
	register int64	*tb0,*tb1,*tb2,*tb3,*ttb;
	register long	i;

	dx*=4;
	x+=4*(5*px+border)+(5*py+border-7)*dx;

	tb0=(int64 *) tbi;
	tb1=tb0+5*w;	for (i=0; i<5; i++) { scale_5_1_hor(tb0+i,x,w); x+=dx; }
	tb2=tb1+5*w;	for (i=0; i<5; i++) { scale_5_1_hor(tb1+i,x,w); x+=dx; }
	tb3=tb2+5*w;	for (i=0; i<5; i++) { scale_5_1_hor(tb2+i,x,w); x+=dx; }

	do
	{
		for (i=0; i<5; i++) { scale_5_1_hor(tb3+i,x,w); x+=dx; }

		scale_5_1_ver(y, tb0, tb1, tb2,	tb3, w); y+=dy;

		ttb=tb0;
		tb0=tb1; tb1=tb2; tb2=tb3; tb3=ttb;
		h--;
	}
	while ( h );
}

#ifdef test

static inline unsigned long getclk()
{
	register unsigned long  i;

 	__asm__ __volatile__("mov %0=ar.itc" : "=r"(i) );

	return i;
}

#define n	400

int main()
{
	long	a,b,c,i;
	int	x[32+1200];
	long long y[n+4];

	for (i=0; i<10; i++)
	{
		a=getclk();
		b=getclk();
		scale_3_1_hor(y  ,(uchar *) (x+16),n/6);
		scale_3_1_hor(y+1,(uchar *) (x+16),n/6);
		scale_3_1_hor(y+2,(uchar *) (x+16),n/6);
		c=getclk();
	}
	printf("%f %f\n",((double) (b-a))/((double) n),((double) (c-b))/((double) n));

	return 0;
}
#endif

